dnl $Id: postlude.m4,v 1.5 2004/01/29 16:03:38 albert Exp $
dnl Copyright(2000): Albert van der Horst, HCC FIG Holland by GNU Public License
include(rom.m4)
include(header.m4)
dnl architectural consequences
dnl Look at this as a knowledge base:
dnl A(define(B),y) means if we have A, then we need B too.
dnl A({B({define(C),y})}) means if we have A and B then we need C too.
dnl A(define(C),y) combined with B(define(C),y) means
dnl if we have A or we have B, then we need C too.
dnl A(define(B),y) followed by C(define(B),n) means
dnl normally A requiries B with an exception for C.

dnl Combinations

dnl Consequences we need in the remainder.
dnl FIXME : this should actually increment M4_HS by 1.
_SOURCEFIELD_({define({M4_HS},{6})})


dnl cludge
_CODEINROM_({define({_BOOTED_}, _yes)})
dnl Alternative for ram, a ram item is an empty space, i.e. 1efault.
_CODEINROM_(
    {define({_VOC_ADDRESS_}, {{_RAM_ITEM(_VOC_SIZE)}})},
    {define({_VOC_ADDRESS_}, )}
)

dnl Hard consequences
_6809_({define({_BITS16_}, _yes)})
dnl The following must evaluate to a decimal numerical expression!
dnl (Because it is used by _RAM_ITEM .)
define({_VOC_SIZE}, {eval((M4_HS+2)*M4_CELLWIDTH)})

dnl Other consequences
dnl _BITS32_({define({M4_NBUF}, 16 )}) NOT YET!
dnl _BITS32_({define({M4_MAXWORDLIST}, 16 )}) NOT YET!

dnl Consequences with exceptions
dnl switch back and forth between protected and real mode.

dnl Defines that directly regulate source inclusions, without depending defines.
define({_NO_SECURITY_}, _yes)}) dnl default
_SECURITY_({define({_NO_SECURITY_}, _no)})}) dnl exception
define({_CIF_IN_}, _yes)})
_ISO_IN_({define({_CIF_IN_}, _no)})})

dnl Detectable error situations. Terminate.
_BITS16_({ _BITS32_({errprint({32 and 16 bits at the same time? Choose one option!
})m4exit(1003)})})
_SOURCEFIELD_({ _LOAD_(, {errprint({You must have BLK to use source fields, hence require loadables.
})m4exit(1009)})})
dnl immediate consequences
_BITS32_({define({M4_CELLWIDTH}, 4)})
_BITS16_({define({M4_CELLWIDTH}, 2)})
_BITS16_({define({M4_INITDP}, {TEXTEND})})
_BITS32_({define({_NEXT}, {_NEXT32})})
_BITS32_({define({_PUSH}, {_PUSH32})})
_BITS32_({define({_2PUSH}, {_2PUSH32})})
divert{}dnl
