

;            ciforth : a generic 6809 ISO FORTH by HCC FIG

; $Id: ci68.gnr,v 1.49.2.1 2004/12/30 20:22:06 albert Exp $
; Copyright (2000): HCC FIG Holland by GNU Public License
;
;HCC FIG Holland : Hobby Computer Club, Forth Interest Group  Holland
        ;  66,106
 ;   ciforth 6809 $Revision: 1.49.2.1 $
;
; For the generic system (to generate ciforth in an other configuration than this one):
;     http://home.hccnet.nl/a.w.m.van.der.horst/ciforth.html
;
; If this is a configured assembly file, it should be accompanied with configured
; documentation (texinfo, ps, html.)
; WITHOUT THE DOCUMENTATION: GIVE UP! GET THE REAL THING!
; You have a configured system, if there are NO curly brackets on the next line.
;                          
;
; Configuration of this particular version:
; 16-bits
; 
; Normally ciforth doesn't observe ISO >IN.
; Contains :
; (there may be no items here.)
;        Security words
;         Loadable words, i.e. all of ISO CORE, more than is needed
;           for a self contained kernel.
;
 ;
; This is an as9 version of ciforth created by ``m4'' from the generic listing.
; It can be assembled using ``as9'' obtainable as part of the forth9.arc
; package. ``as9.exe'' requires MSDOS, emudos under Linux, or equivalent.


        ;
; ########################################################################################
;                       PREPARATION (no code)
; ########################################################################################
FIGREL  EQU     4       ; FIG RELEASE #
FIGREV  EQU     0       ; FIG REVISION #
USRVER  EQU     0      ; USER VERSION NUMBER, a digit now
;
; HARDWARE
; Running under maisforth is not problem.
USART_DATA      EQU     $BE00
USART_STATUS    EQU     $BE01
USART_MODE      EQU     $BE02
USART_CMD       EQU     $BE03
;
;      VERY ELEMENTARY .
CW      EQU     2    ; Size of a cell in Forth, not in the bootcode.
ERRORSCREEN EQU     48    ; Screen where the error messages start.
;
;      MEMORY LAYOUT.
; Normally this is specified at the m4 configuration level.
; For a configured system these values can be changed at this single place. 
NBUF    EQU     8    ; No. of buffers, or screens 
KBBUF   EQU     1024      ; Data bytes per disk buffer
US      EQU     $40*CW  ; User variable space
EM      EQU     $6000     ; Where the memory ends w.r.t. ORIG.
RTS     EQU     $0100    ; Return stack & terminal input buffer
;

;
;      ASCII CHARACTER EQUIVALENTS
; This assembler has the nasty habit of ignoring 'A'+1 everything after
; the second quote.
;
AAT     EQU     '@'
ABL     EQU     ' '     ; SPACE
ACR     EQU     $0D     ; CR
ASO     EQU     '['
ASC     EQU     ']'
ADOT    EQU     '.'
APERC   EQU     '%'
AA      EQU     'A'
AS      EQU     'S'
A9      EQU     '9'
A0      EQU     '0'
A1      EQU     '1'
ARC     EQU     ')'
ADQ     EQU     '"'
ACM     EQU     ','
ALF     EQU     $0A     ; LINE FEED, USED INTERNALLY AS
                        ; LINE ENDER
AFF     EQU     $0C     ; FORM FEED
BELL    EQU     $07     ; ^G
BSIN    EQU     $08     ; INPUT DELETE CHARACTER
BSOUT   EQU     $08     ; OUTPUT BACKSPACE ( ^H )
;
;      HEADER RELATED EQUATES
B_DUMMY   EQU     $01     ; dea is dummy, from vocabulary link
B_INVIS   EQU     $02     ; dea is invisible, "smudged".
B_IMMED   EQU     $04     ; dea is a immediate.
B_DENOT   EQU     $08     ; dea is a denotation.
C_HOFFSET EQU     0       ; Offsets of code field in cells, w.r.t. dea
D_HOFFSET EQU     1       ; Same for data field
F_HOFFSET EQU     2       ; Same for flag field
L_HOFFSET EQU     3       ; Same for link field
N_HOFFSET EQU     4       ; Same for name field
PH_OFFSET EQU     5   ; Past header field: Start of data area. 
BD_OFFSET EQU     5+1 ; Start of BODY for CREATEd word.

;

 ;  

STRUSA  EQU     EM-US         ; User area at end 
; 

STRTIB  EQU     STRUSA-RTS      ; Start return stack area
                                ; Under this : data stack
INITR0  EQU     STRUSA         ; Grows down
INITS0  EQU     STRTIB          ; Grows down
 ;  



BPS     EQU     512             ;Bytes/sector, common to all of MSDOS
SPB     EQU     KBBUF/BPS
;
     ORG     $C000

ORG0:
; ########################################################################################
;                       FORTH STARTUP CODE
; ########################################################################################


COLD_ENTRY:
        LDU     2*CW+USINI    ;SPO
        LDS     3*CW+USINI    ;RPO
        LDY     #CLD1  ;HIP
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;
;
        ;

        ;
;
; Normally there are no jumps to NEXT at all 
; If you want debug, you may have to redefine _NEXT too.
XDPUSH:  PSHU   X
DPUSH:  PSHU    D
NEXT:
         LDX   ,Y++           ; NEXT
; 
         JMP   [C_HOFFSET*CW,X]
;
;       Dictionary starts here.

DP0:
; Vocabularies all end in a link to 0.
; Only the word FORTH links to the DENOTATION wordlist,
; that in turn links to 0.


;  *********
;  *   '   *
;  *********
;
N_TICK:   FDB      1
        FCC      "'"
TICK:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED+B_DENOT
        FDB    0
        FDB    N_TICK

        FDB      ITICK
        FDB      LITER
        FDB      SEMIS
;

;  *********
;  *   &   *
;  *********
;
N_DCHAR:   FDB      1
        FCC      "&"
DCHAR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+TICK
        FDB    N_DCHAR

        FDB      INBRS
        FDB      SWAP, DROP
        FDB      LDUP, QBL
        FDB      LIT, 10, QERR
        FDB      LITER
        FDB      QDELIM
        FDB      SEMIS
;

;  *********
;  *   ^   *
;  *********
;
N_DCTL:   FDB      1
        FCC      "^"
DCTL:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DCHAR
        FDB    N_DCTL

        FDB      INBRS
        FDB      SWAP, DROP
        FDB      LDUP, QBL
        FDB      LIT, 10, QERR
        FDB      LIT, AAT, LSUB
        FDB      LITER
        FDB      QDELIM
        FDB      SEMIS
;

;  *********
;  *   0   *
;  *********
;
N_DEN0:   FDB      1
        FCC      "0"
DEN0:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DCTL
        FDB    N_DEN0

;  *********
;  *   1   *
;  *********
;
N_DEN1:   FDB      1
        FCC      "1"
DEN1:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN0
        FDB    N_DEN1

;  *********
;  *   2   *
;  *********
;
N_DEN2:   FDB      1
        FCC      "2"
DEN2:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN1
        FDB    N_DEN2

;  *********
;  *   3   *
;  *********
;
N_DEN3:   FDB      1
        FCC      "3"
DEN3:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN2
        FDB    N_DEN3

;  *********
;  *   4   *
;  *********
;
N_DEN4:   FDB      1
        FCC      "4"
DEN4:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN3
        FDB    N_DEN4

;  *********
;  *   5   *
;  *********
;
N_DEN5:   FDB      1
        FCC      "5"
DEN5:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN4
        FDB    N_DEN5

;  *********
;  *   6   *
;  *********
;
N_DEN6:   FDB      1
        FCC      "6"
DEN6:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN5
        FDB    N_DEN6

;  *********
;  *   7   *
;  *********
;
N_DEN7:   FDB      1
        FCC      "7"
DEN7:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN6
        FDB    N_DEN7

;  *********
;  *   8   *
;  *********
;
N_DEN8:   FDB      1
        FCC      "8"
DEN8:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN7
        FDB    N_DEN8

;  *********
;  *   9   *
;  *********
;
N_DEN9:   FDB      1
        FCC      "9"
DEN9:        FDB    DOCOL
        FDB    LNUMB
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN8
        FDB    N_DEN9

;

;  *********
;  *   -   *
;  *********
;
N_DENM:   FDB      1
        FCC      "-"
DENM:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DEN9
        FDB    N_DENM

        FDB      PNUMB, DNEGA, SDLITE
        FDB      SEMIS
;

;  *********
;  *   +   *
;  *********
;
N_DENP:   FDB      1
        FCC      "+"
DENP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DENM
        FDB    N_DENP

        FDB      PNUMB, SDLITE
        FDB      SEMIS
;

;  *********
;  *   "   *
;  *********
;
N_DENQ:   FDB      1
        FCC      '"'
DENQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED+B_DENOT
        FDB    -C_HOFFSET*CW+DENP
        FDB    N_DENQ

        FDB      LIT, SKIP, COMMA        ;  'SKIP , HERE >R 0 ,
        FDB      HERE, TOR, ZERO, COMMA
DENQ1:
        FDB      LIT, ADQ, PPARS         ;           BEGIN &" (PARSE)
        FDB      INBRS, LDUP, LIT, ADQ, EQUAL ;           IN[] DUP &" =
        FDB      ZBRAN
        FDB      DENQ2-*-CW                 ;           WHILE
        FDB      TDROP, ONEP             ;           2DROP 1+ R@ $+!
        FDB      LDUP, ALLOT, RR, SADD
        FDB      BRAN
        FDB      DENQ1-*-CW                  ;           REPEAT
DENQ2:
        FDB      QBL, ZEQU
        FDB      LIT, 10, QERR           ;           ?BLANK 0= 5 ?ERROR
        FDB      DROP                    ;                DROP R@ $+!
        FDB      LDUP, ALLOT, RR, SADD
        FDB      FROMR, SFET, DLITE      ;           R> $@ POSTPONE DLITERAL ;
        FDB      SEMIS
;

; The FORTH vocabulary is the only one not to link to zero.
; It links to the DENOTATION vocabulary.
;  *************
;  *   FORTH   *
;  *************
;
N_FORTH:   FDB      5
        FCC      "FORTH"
FORTH:        FDB    DODOE
        FDB    1024
        FDB    B_IMMED
        FDB    DENOTBODY 
        FDB    N_FORTH

        FDB      DOVOC
        FDB      0       ; END OF VOCABULARY LIST

        FDB    $0
        FDB    0
        FDB    B_DUMMY
        FDB    -C_HOFFSET*CW+TASK
        FDB    0

;
;

;  ************
;  *   CORE   *
;  ************
;
N_CORE:   FDB      4
        FCC      "CORE"
CORE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    0
        FDB    N_CORE

        FDB      ZERO    ; Not (fully) present.
        FDB      SEMIS
;

;  ***********
;  *   CPU   *
;  ***********
;
N_LCPU:   FDB      3
        FCC      "CPU"
LCPU:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CORE
        FDB    N_LCPU

       FDB      LIT, $06E09, LIT, $4      ; '6809'     
        FDB      SEMIS
;

;  ***************
;  *   VERSION   *
;  ***************
;
N_LVERSION:   FDB      7
        FCC      "VERSION"
LVERSION:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LCPU
        FDB    N_LVERSION

;       If M4_VERSION exists and contains a . it is an official release
        FDB      SKIP
         FDB      3
SB0: FCC      "1.0"
       
        FDB      LIT, SB0
        FDB      LIT, 3
        FDB      SEMIS
;

;  ************
;  *   NAME   *
;  ************
;
N_LNAME:   FDB      4
        FCC      "NAME"
LNAME:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LVERSION
        FDB    N_LNAME

        FDB      SKIP
         FDB      7
SB1: FCC      "ciforth"
       
        FDB      LIT, SB1
        FDB      LIT, 7
        FDB      SEMIS
;

;  ****************
;  *   SUPPLIER   *
;  ****************
;
N_SUPPLIER:   FDB      8
        FCC      "SUPPLIER"
SUPPLIER:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LNAME
        FDB    N_SUPPLIER

        FDB      SKIP
         FDB      15
SB2: FCC      "HCC FIG Holland"
       
        FDB      LIT, SB2
        FDB      LIT, 15
        FDB      SEMIS
;
;

;  ******************
;  *   DENOTATION   *
;  ******************
;
N_DENOT:   FDB      10
        FCC      "DENOTATION"
DENOT:        FDB    DODOE
        FDB    1038
        FDB    B_IMMED
        FDB    FORTH
        FDB    N_DENOT

        FDB      DOVOC
        FDB      -C_HOFFSET*CW+FORTH     ; NEXT VOCABULARY 
DENOTBODY:

        FDB    $0
        FDB    0
        FDB    B_DUMMY
        FDB    -C_HOFFSET*CW+DENQ
        FDB    0

;

;  *****************
;  *   ASSEMBLER   *
;  *****************
;
N_ASSEM:   FDB      9
        FCC      "ASSEMBLER"
ASSEM:        FDB    DODOE
        FDB    1052
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+DENOT
        FDB    N_ASSEM

        FDB      DOVOC
        FDB      -C_HOFFSET*CW+DENOT       ; NEXT VOCABULARY 

        FDB    $0
        FDB    0
        FDB    B_DUMMY
        FDB    0 
        FDB    0

;

;  *******************
;  *   ENVIRONMENT   *
;  *******************
;
N_ENV:   FDB      11
        FCC      "ENVIRONMENT"
ENV:        FDB    DODOE
        FDB    1066
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+ASSEM
        FDB    N_ENV

        FDB      DOVOC
        FDB      -C_HOFFSET*CW+ASSEM       ; NEXT VOCABULARY 

        FDB    $0
        FDB    0
        FDB    B_DUMMY
        FDB    -C_HOFFSET*CW+SUPPLIER
        FDB    0

;

;  ************
;  *   NOOP   *
;  ************
;
N_NOOP:   FDB      4
        FCC      "NOOP"
NOOP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ENV
        FDB    N_NOOP

       LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***********
;  *   LIT   *
;  ***********
;
N_LIT:   FDB      3
        FCC      "LIT"
LIT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+NOOP
        FDB    N_LIT

    LDD   ,Y++           ; Get Literal
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]          ; TO TOP OF STACK
;

;  ***************
;  *   EXECUTE   *
;  ***************
;
N_EXEC:   FDB      7
        FCC      "EXECUTE"
EXEC:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LIT
        FDB    N_EXEC

    PULU  X            ; GET XT
    JMP   [C_HOFFSET*CW,X]
;

;  ***************
;  *   RECURSE   *
;  ***************
;
N_RECURSE:   FDB      7
        FCC      "RECURSE"
RECURSE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+EXEC
        FDB    N_RECURSE

        FDB      LATEST, COMMA
        FDB      SEMIS
;

;  **************
;  *   BRANCH   *
;  **************
;
N_BRAN:   FDB      6
        FCC      "BRANCH"
BRAN:        FDB    PH_OFFSET-C_HOFFSET*CW+SKIP
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RECURSE
        FDB    N_BRAN

;

;  ************
;  *   SKIP   *
;  ************
;
N_SKIP:   FDB      4
        FCC      "SKIP"
SKIP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BRAN
        FDB    N_SKIP

BRAN1:
    LDD   ,Y++             ; Get offset value
    LEAY  D,Y            ; Add offset to instruction pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***************
;  *   0BRANCH   *
;  ***************
;
N_ZBRAN:   FDB      7
        FCC      "0BRANCH"
ZBRAN:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SKIP
        FDB    N_ZBRAN

    PULU  D
    CMPD  #0             ; Is top of stack zero?
    BEQ   BRAN1          ; Yes, must branch
    LEAY  CW,Y            ; No, skip branch offset
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;
;

;  **************
;  *   (LOOP)   *
;  **************
;
N_XLOOP:   FDB      6
        FCC      "(LOOP)"
XLOOP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ZBRAN
        FDB    N_XLOOP

    LDD   #$0001         ; Assume an increment of 1
XLOO1:
    STA   ,-U              ; Remember increments sign.
    ADDD  0,S            ; Add increment to loop index
    STD   0,S            ; Put the new index on the stack
    SUBD  2,S            ; Compare index with limit
    EORA  ,U+              ; Same sign then increment?
    BMI   BRAN1            ; Branch if not past limit
    LEAS  6,S            ; Drop the index, the limit and address
    LEAY  CW,Y           ; Skip the branch offset
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***************
;  *   (+LOOP)   *
;  ***************
;
N_XPLOO:   FDB      7
        FCC      "(+LOOP)"
XPLOO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+XLOOP
        FDB    N_XPLOO

    PULU  D               ; Get the increment value
    BRA   XLOO1          ; Go do loop
   LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]           ;Helpfull for disassembly.
;

;  ************
;  *   (DO)   *
;  ************
;
N_XDO:   FDB      4
        FCC      "(DO)"
XDO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+XPLOO
        FDB    N_XDO

        LDD   ,Y++             ; Get offset value                         *
         LEAX  D,Y              ;Make absolute
XDO1:
    PSHS  X            ; Push to system stack
    PULU  D,X            ; Get initial index and limit values
    PSHS  X,D            ; Push to system stack
    LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *************
;  *   (?DO)   *
;  *************
;
N_XQDO:   FDB      5
        FCC      "(?DO)"
XQDO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+XDO
        FDB    N_XQDO

        LDD   ,Y++             ; Get offset value                         *
         LEAX  D,Y              ;Make absolute
         LDD   ,U
         CMPD   2,U
         BNE    XDO1
         LEAU   CW*2,U          ;Thow away loop limits.
         TFR     X,Y
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   I   *
;  *********
;
N_IDO:   FDB      1
        FCC      "I"
IDO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+XQDO
        FDB    N_IDO

    LDD   0,S            ; Get the index
    PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]          ; TO PARAMETER STACK
;

;  *********
;  *   J   *
;  *********
;
N_JDO:   FDB      1
        FCC      "J"
JDO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+IDO
        FDB    N_JDO

    LDD   6,S            ; Get the index
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]          ; TO PARAMETER STACK
;

;  **************
;  *   UNLOOP   *
;  **************
;
N_UNLOOP:   FDB      6
        FCC      "UNLOOP"
UNLOOP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+JDO
        FDB    N_UNLOOP

        FDB      LIT, RDROP, COMMA
        FDB      LIT, RDROP, COMMA
        FDB      LIT, RDROP, COMMA
        FDB      SEMIS
;

;  ***************
;  *   +ORIGIN   *
;  ***************
;
N_PORIG:   FDB      7
        FCC      "+ORIGIN"
PORIG:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+UNLOOP
        FDB    N_PORIG

        FDB      LIT
        FDB      USINI
        FDB      PLUS
        FDB      SEMIS
;
;      Initialisation block for user variables through DOC-LINK
;       <<<<< must be in same order as user variables >>>>>
;
;        FDB      WARM_ENTRY FIXME
;        FDB      COLD_ENTRY
USINI:  FDB      STRUSA  ; User area currently in use, cold value same as next.
        FDB      STRUSA  ; INIT (U0) user area of the main task 1
        FDB      INITS0  ; INIT (S0)         2
        FDB      INITR0  ; INIT (R0)         3
        FDB      STRTIB  ; INIT (TIB)        4
        FDB      BSIN    ; RUBOUT: get rid of latest char 5
        FDB      0       ; AVAILABLE         6
        FDB      1       ; INIT (WARNING)     7
        FDB      INITDP  ;      INIT (FENCE)  8
DPA:    FDB      INITDP  ;      INIT (DP)     9
        FDB      -C_HOFFSET*CW+ENV ;       INIT (VOC-LINK) 10
        FDB      0       ; INIT (OFFSET) 
        FDB      0, 0            ; WHERE             12 13 
        FDB      0, STRTIB       ;REMAINDER   14 15 
        ZMB     US-*+USINI        ; All user can be initialised.
;
;      <<<<< end of data used by cold start >>>>>

;  *************
;  *   DIGIT   *
;  *************
;
N_DIGIT:   FDB      5
        FCC      "DIGIT"
DIGIT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PORIG
        FDB    N_DIGIT

        CLRA                 ; Clear high byte
        LDB   3,U            ; Ascii digit is low byte of 2nd on the stack
        SUBB  #A0           ; Convert to binary
        BLO   DIGI2          ; Not a number
        CMPB  #$0A           ; Ascii 0-9?
        BLO   DIGI1          ; Yes, check against base
        CMPB  #$11           ; Ascii A-Z?
        BLO   DIGI2          ; No, less than 'A'
        CMPB  #$2A
        BHI   DIGI2          ; No, greater than 'Z'
        SUBB  #7             ; Legal letter - convert to binary
DIGI1   CMPB  1,U            ; Compare number to base (on top of stack)

        BHS   DIGI2          ; Error if greater than or equal
        STD   2,U            ; No error leave number on the stack
        LDD   #-1            ; True flag
        STD   0,U            ; Put flag on top of stack
        BRA   DIGI3          ; NEXT
DIGI2   LDD   #0             ; False flag
        STD   0,U            ; Put it on the stack
DIGI3   LDX   ,Y++           ; NEXT
        JMP   [,X++]
;

;  ***************
;  *   (MATCH)   *
;  ***************
;
N_PMATCH:   FDB      7
        FCC      "(MATCH)"
PMATCH:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DIGIT
        FDB    N_PMATCH

        FDB      TOR
        FDB      RR, TFFA, FETCH
        FDB      LIT, B_INVIS|B_DUMMY, LAND ;Get flags.
        FDB      ZEQU
        FDB      LDUP
        FDB      ZBRAN
        FDB      MATS2-*-CW
        FDB      DROP
        FDB      RR, TNFA, FETCH, FETCH
        FDB      OVER, LSUB
;
; The following four lines take care of denotations.
        FDB      LDUP, ZLESS  ;Ignorable length difference.
        FDB      RR, TFFA, FETCH, LIT, B_DENOT, LAND ;Get flag.
        FDB      LAND  ;Denotation applicable. 
        FDB      ZEQU, LAND ;This AND is actually an OR.
;
        FDB      ZEQU
        FDB      LDUP
        FDB      ZBRAN
        FDB      MATS2-*-CW
        FDB      DROP, OVER
        FDB      RR, TNFA, FETCH, SFET
        FDB      CORA, ZEQU  ; Compare equals.
MATS2:  FDB      FROMR, SWAP
        FDB      SEMIS
;

;  **************
;  *   ?BLANK   *
;  **************
;
N_QBL:   FDB      6
        FCC      "?BLANK"
QBL:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PMATCH
        FDB    N_QBL

        FDB      LBL, ONEP, LESS
        FDB      SEMIS
;

;  ************
;  *   IN[]   *
;  ************
;
N_INBRS:   FDB      4
        FCC      "IN[]"
INBRS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QBL
        FDB    N_INBRS

        FDB      SRC, CELLP, TFET
        FDB      OVER, EQUAL
        FDB      ZBRAN
        FDB      INBRS1-*-CW
        FDB      ZERO
        FDB      BRAN
        FDB      INBRS2-*-CW
INBRS1:
        FDB      LDUP
        
        FDB      CFET
        FDB      ONE, LIN, PSTORE
INBRS2:
        FDB      SEMIS
;

;  **************
;  *   (WORD)   *
;  **************
;
N_LPWORD:   FDB      6
        FCC      "(WORD)"
LPWORD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+INBRS
        FDB    N_LPWORD

        FDB      X
PWORD0: FDB      DROP
        FDB      INBRS, QBL
        FDB      OVER, SRC, CELLP, FETCH, LSUB ; At end?
        FDB      LAND, ZEQU
        FDB      ZBRAN
        FDB      PWORD0-*-CW

        FDB      X
PWORD1: FDB      DROP
        FDB      INBRS, QBL
        FDB      ZBRAN
        FDB      PWORD1-*-CW

        FDB      OVER, LSUB
        
        FDB      SEMIS
;

;  ***************
;  *   (PARSE)   *
;  ***************
;
N_PPARS:   FDB      7
        FCC      "(PARSE)"
PPARS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LPWORD
        FDB    N_PPARS

        FDB      SRC, CELLP, TFET
        FDB      OVER, LSUB
        
        FDB      ROT, SSPLIT, TSWAP
        FDB      ZEQU
        FDB      ZBRAN
        FDB      PPARS8-*-CW
        FDB      DROP, SRC, CELLP, FETCH
PPARS8: 
        FDB      LIN, STORE
        FDB SEMIS
;

;  ***********
;  *   SRC   *
;  ***********
;
N_SRC:   FDB      3
        FCC      "SRC"
SRC:        FDB    DOUSE
        FDB    27*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+PPARS
        FDB    N_SRC
      ; And 28 and 29.
;


;  **************
;  *   SOURCE   *
;  **************
;
N_SOURCE:   FDB      6
        FCC      "SOURCE"
SOURCE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SRC
        FDB    N_SOURCE

        FDB      SRC, FETCH
        FDB      SRC, CELLP, FETCH
        FDB      OVER, LSUB
        FDB      SEMIS
;

;  ***********
;  *   >IN   *
;  ***********
;
N_IIN:   FDB      3
        FCC      ">IN"
IIN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SOURCE
        FDB    N_IIN

        FDB      LIN, FETCH
        FDB      SRC, FETCH, LSUB     
        FDB      PIIN, STORE
        FDB      PIIN
        FDB      SEMIS
;
;

;  **********
;  *   CR   *
;  **********
;
N_CR:   FDB      2
        FCC      "CR"
CR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+IIN
        FDB    N_CR

        FDB      LIT,ALF
        FDB      EMIT
        FDB      ZERO, LOUT, STORE
        FDB      SEMIS
;

;  *************
;  *   CMOVE   *
;  *************
;
N_LCMOVE:   FDB      5
        FCC      "CMOVE"
LCMOVE:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CR
        FDB    N_LCMOVE

    PSHS  Y              ; Save the instruction pointer (Y).
CMOV0:
    PULU  D                ; Get the count
    ADDD  0,U            ; Add it to the destination address
    PULU  X,Y            ; Destination in X, Source in Y
    PSHU  D              ; Put final destination addr. on stack
    BRA CMOV2
CMOV1:
    LDA   ,Y+            ; Do the move
    STA   ,X+
CMOV2:
    CMPX  0,U            ; At the final destination?
    BLT   CMOV1          ; If not, continue
    LEAU  2,U            ; Drop final destination from the stack
    PULS  Y              ; Restore the instruction pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   MOVE   *
;  ************
;
N_LMOVE:   FDB      4
        FCC      "MOVE"
LMOVE:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LCMOVE
        FDB    N_LMOVE

    PSHS  Y              ; Save the instruction pointer (Y).
    LDD   ,U           ; Get the count.
    LDY   2,U
    LDX   4,U
    CMPY  4,U          ; Carry set : to lower memory
    LEAY  D,Y            ; Leaves carry alone!
    LEAX  D,X            ; Leaves carry alone!
    BCC   MOVE1          ; Moving to higher memory, okay.
    CMPX  2,U
    BCC   CMOV0          ; Overlap, so use other direction.
MOVE1:
    LEAU  4,U          ; Only leave source start.
    ANDB  #1
    BEQ   LMOV2          ; Gracefully handle zero count.
    LDA   ,-X            ; Make it even
    STA   ,-Y
    BRA   LMOV2
LMOV1:
    LDD   ,--X            ; Do the move
    STD   ,--Y
LMOV2:
    CMPX  0,U          ; At the final source?
    BNE   LMOV1          ; If not, continue
    LEAU  2,U            ; Drop final destination from the stack
    PULS  Y              ; Restore the instruction pointer
    LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***********
;  *   UM*   *
;  ***********
;
N_USTAR:   FDB      3
        FCC      "UM*"
USTAR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LMOVE
        FDB    N_USTAR

; Was 172 states, but used unprotected system stack. Now 136/142/148
        LDD   0,U            ; Get OP1
        LDX   2,U            ; Get OP2
        PSHS  X,D            ; Save it on return stack

                             ; OP1 high byte already there.
        LDB    2,S           ; Get OP2 high byte
        MUL                  ; Multply
        STD   ,U             ; Store ms partial product

        LDA   1,S            ; Get OP1 low byte
        LDB   3,S            ; Get OP2 low byte
        MUL                  ; Multiply
        STD   2,U            ; Store ls partial product

        LDA   ,S             ; Get OP1 high byte
        LDB   3,S            ; Get OP2 low byte
        MUL                  ; Multiply
        ADDD  1,U            ; Add to middle partial product
        STD   1,U
        BCC   USTA1          ; Check for a carry into high byte
        INC   ,U             ; Add carry if neccesary
USTA1:
        LDA   1,S            ; Get OP1 low byte
        LDB   2,S            ; Get OP2 high byte
        MUL                  ; Multiply
        ADDD  1,U            ; Add to middle partial product
        STD   1,U
        BCC   USTA2          ; Check for a carry into high byte
        INC   0,U            ; Add carry if neccesary
USTA2:
        LEAS  4,S            ; Throw away temporaries.
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]                ;STORE DOUBLE CELL
;

;  **************
;  *   UM/MOD   *
;  **************
;
N_USLAS:   FDB      6
        FCC      "UM/MOD"
USLAS:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+USTAR
        FDB    N_USLAS

       LDX   #$10
       ASL   5,U
       ROL   4,U        ;initial shift (lo 16) 
       LDD   2,U
BEG1:  ROLB             ;shift left hi 16
       ROLA
       BCC   ELSE       ;1xxxx: 17 bits, subtract is ok
       SUBD  0,U
       ANDCC #$0FE      ; clear cy
       BRA   THE1
ELSE:  SUBD  0,U        ;0xxxx: 16 bits test subtract
       BCC   THE1       ;cs=can't subtr
       ADDD  0,U        ;add back in
THE1:                   ;cy=0 if sub ok 1 if no subtract
       ROL   5,U
       ROL   4,U        ;rotate cy into result
       LEAX  -1,X
       BNE   BEG1       ;loop 16 times
       TFR   D,X        ;mod ->X
       LDD   4,U
       COMA
       COMB             ;invert to get true quot in D
       LEAU  6,U        ;clean stack
        PSHU    X,D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***********
;  *   AND   *
;  ***********
;
N_LAND:   FDB      3
        FCC      "AND"
LAND:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+USLAS
        FDB    N_LAND

        PULU  D              ; Get top of stack
        ANDA  0,U            ; AND high order byte
        ANDB  1,U            ; AND low order byte
        STD   0,U            ; Leave result on stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   OR   *
;  **********
;
N_LOR:   FDB      2
        FCC      "OR"
LOR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LAND
        FDB    N_LOR

        PULU  D              ; Get top of stack
        ORA  0,U            ; OR high order byte
        ORB  1,U            ; OR low order byte
        STD   0,U            ; Leave result on stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***********
;  *   XOR   *
;  ***********
;
N_LXOR:   FDB      3
        FCC      "XOR"
LXOR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LOR
        FDB    N_LXOR

        PULU  D              ; Get top of stack
        EORA  0,U            ; EOR high order byte
        EORB  1,U            ; EOR low order byte
        STD   0,U            ; Leave result on stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **************
;  *   INVERT   *
;  **************
;
N_INVERT:   FDB      6
        FCC      "INVERT"
INVERT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LXOR
        FDB    N_INVERT

        COM     0,U
        COM     1,U
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   DSP@   *
;  ************
;
N_SPFET:   FDB      4
        FCC      "DSP@"
SPFET:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+INVERT
        FDB    N_SPFET

        TFR   U,D            ; Get current parameter stack pointer
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   DSP!   *
;  ************
;
N_SPSTO:   FDB      4
        FCC      "DSP!"
SPSTO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SPFET
        FDB    N_SPSTO

        LDU   0,U            ; Get parameter stack pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;


;  *************
;  *   DEPTH   *
;  *************
;
N_DEPTH:   FDB      5
        FCC      "DEPTH"
DEPTH:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SPSTO
        FDB    N_DEPTH

        FDB      SZERO, FETCH
        FDB      SPFET
        FDB      LSUB
        FDB      ONE, RSHIFT
        FDB      ONEM
        FDB      SEMIS
;
;

;  ************
;  *   RSP@   *
;  ************
;
N_RPFET:   FDB      4
        FCC      "RSP@"
RPFET:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DEPTH
        FDB    N_RPFET
      ;(S1) <- (RP)
        PSHU  S              ; Get current return stack pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   RSP!   *
;  ************
;
N_RPSTO:   FDB      4
        FCC      "RSP!"
RPSTO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RPFET
        FDB    N_RPSTO

        PULU  S              ; Get current return stack pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   EXIT   *
;  ************
;
N_EXIT:   FDB      4
        FCC      "EXIT"
EXIT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RPSTO
        FDB    N_EXIT

        PULS  Y              ; Fetch old IP
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   CO   *
;  **********
;
N_CO:   FDB      2
        FCC      "CO"
CO:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+EXIT
        FDB    N_CO

        PULS    D
        EXG     Y,D
        PSHS    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***********
;  *   (;)   *
;  ***********
;
N_SEMIS:   FDB      3
        FCC      "(;)"
SEMIS:        FDB    PH_OFFSET-C_HOFFSET*CW+EXIT
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CO
        FDB    N_SEMIS

;

;  *************
;  *   LEAVE   *
;  *************
;
N_LLEAV:   FDB      5
        FCC      "LEAVE"
LLEAV:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SEMIS
        FDB    N_LLEAV
  ;LIMIT <- INDEX
        FDB      RDROP, RDROP, RDROP
        FDB      SEMIS
;

;  **********
;  *   >R   *
;  **********
;
N_TOR:   FDB      2
        FCC      ">R"
TOR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LLEAV
        FDB    N_TOR
        ; (R1) <- (S1)
        PULU  D              ; Get top of parameter stack
        PSHS  D              ; Push it to the return stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   R>   *
;  **********
;
N_FROMR:   FDB      2
        FCC      "R>"
FROMR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TOR
        FDB    N_FROMR
      ;(S1) <- (R1)
        PULS  D              ; Get top of return stack
        PSHU  D              ; Push it to the parameter stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *************
;  *   RDROP   *
;  *************
;
N_RDROP:   FDB      5
        FCC      "RDROP"
RDROP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FROMR
        FDB    N_RDROP
      ;(S1) <- (R1)
        LEAS   2,S
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   R@   *
;  **********
;
N_RR:   FDB      2
        FCC      "R@"
RR:        FDB    PH_OFFSET-C_HOFFSET*CW+IDO
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RDROP
        FDB    N_RR

;

;  **********
;  *   0=   *
;  **********
;
N_ZEQU:   FDB      2
        FCC      "0="
ZEQU:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RR
        FDB    N_ZEQU

        PULU  D              ; Get top of stack
        LDX   #-1             ; Assume TRUE
        CMPD  #0             ; Compare to zero
        BEQ   ZEQ1           ; See if assumtion is correct
        LEAX  1,X           ; No, it is FALSE
ZEQ1    PSHU  X              ; Leave flag
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   0<   *
;  **********
;
N_ZLESS:   FDB      2
        FCC      "0<"
ZLESS:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ZEQU
        FDB    N_ZLESS

        PULU  D              ; Get top of stack
        LDX   #-1             ; Assume TRUE
        CMPD  #0             ; Compare to zero
        BLT   ZLESS1         ; Check assumption
        LEAX  1,X           ; No, it is FALSE
ZLESS1  PSHU  X              ; Leave flag
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   +   *
;  *********
;
N_PLUS:   FDB      1
        FCC      "+"
PLUS:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ZLESS
        FDB    N_PLUS

        PULU  D              ; Get top of stack
        ADDD  0,U            ; Add it to new top of stack
        STD   0,U            ; Put sum on top of stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   D+   *
;  **********
;
N_DPLUS:   FDB      2
        FCC      "D+"
DPLUS:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PLUS
        FDB    N_DPLUS

        CLRA                 ; Clear A and the carry bit
        LDB   #4             ; Do four bytes
        TFR   U,X            ; Get a reference to the top of the stack
DPLU1   LDA   3,X            ; Get a byte from D2
        ADCA  7,X            ; Add it to a byte from D1 with the carry
        STA   7,X            ; Update
        LEAX  -1,X           ; Adjust X
        DECB                 ; Decrement counter
        BNE   DPLU1          ; Loop if not done
        LEAU  4,U            ; Adjust stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **************
;  *   NEGATE   *
;  **************
;
N_NEGATE:   FDB      6
        FCC      "NEGATE"
NEGATE:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DPLUS
        FDB    N_NEGATE

        CLRA
        CLRB                 ; Clear D
        SUBD  0,U            ; Get twos complement in D
        STD   0,U            ; Update
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***************
;  *   DNEGATE   *
;  ***************
;
N_DNEGA:   FDB      7
        FCC      "DNEGATE"
DNEGA:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+NEGATE
        FDB    N_DNEGA

        COM   0,U            ; Complement the high order bytes of
        COM   1,U            ; The double number
        COM   2,U            ;
        NEG   3,U            ; Twos complement the lowest byte
        BNE   DMIN1          ; And add carrys as needed
        INC   2,U            ;
        BNE   DMIN1          ;
        INC   1,U            ;
        BNE   DMIN1          ;
        INC   0,U            ;
DMIN1:
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   OVER   *
;  ************
;
N_OVER:   FDB      4
        FCC      "OVER"
OVER:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DNEGA
        FDB    N_OVER

        LDD   2,U            ; Get 2nd item on stack
        PSHU  D              ; Put it on the stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   DROP   *
;  ************
;
N_DROP:   FDB      4
        FCC      "DROP"
DROP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+OVER
        FDB    N_DROP

        LEAU  2,U            ; Adjust stack pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *************
;  *   2DROP   *
;  *************
;
N_TDROP:   FDB      5
        FCC      "2DROP"
TDROP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DROP
        FDB    N_TDROP

        LEAU  4,U            ; Adjust stack pointer
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   SWAP   *
;  ************
;
N_SWAP:   FDB      4
        FCC      "SWAP"
SWAP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TDROP
        FDB    N_SWAP

        PULU  X              ; Get top of stack
        PULU  D              ; Get 2nd on stack
        PSHU    X,D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ***********
;  *   DUP   *
;  ***********
;
N_LDUP:   FDB      3
        FCC      "DUP"
LDUP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SWAP
        FDB    N_LDUP

        LDD   0,U            ; Get top of stack
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   2DUP   *
;  ************
;
N_TDUP:   FDB      4
        FCC      "2DUP"
TDUP:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LDUP
        FDB    N_TDUP

        LDD   0,U            ; Get high order word
        LDX   2,U            ; Get low order word
        PSHU    X,D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *************
;  *   2SWAP   *
;  *************
;
N_TSWAP:   FDB      5
        FCC      "2SWAP"
TSWAP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TDUP
        FDB    N_TSWAP

        FDB      ROT, TOR
        FDB      ROT, FROMR
        FDB      SEMIS
;

;  *************
;  *   2OVER   *
;  *************
;
N_TOVER:   FDB      5
        FCC      "2OVER"
TOVER:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TSWAP
        FDB    N_TOVER

        LDX   6,U            ; Get 2nd item on stack
        LDD   4,U            ; Get 2nd item on stack
        PSHU    X,D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   +!   *
;  **********
;
N_PSTORE:   FDB      2
        FCC      "+!"
PSTORE:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TOVER
        FDB    N_PSTORE

        PULU  X              ; Get address
        PULU  D              ; Get increment
        ADDD  0,X            ; Do addition
        STD   0,X            ; Store addition
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **************
;  *   TOGGLE   *
;  **************
;
N_TOGGL:   FDB      6
        FCC      "TOGGLE"
TOGGL:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PSTORE
        FDB    N_TOGGL

        PULU  D,X            ; Get bit pattern in B, address in X
        EORA  0,X            ; Do the TOGGLE
        STA   0,X            ; Replace ms byte
        EORB  1,X            ; Do the TOGGLE
        STB   1,X            ; Replace ls byte
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   @   *
;  *********
;
N_FETCH:   FDB      1
        FCC      "@"
FETCH:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TOGGL
        FDB    N_FETCH

        LDD   [0,U]          ; Fetch word pointed to by top of stack
        STD   0,U            ; Put word on the top of stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   C@   *
;  **********
;
N_CFET:   FDB      2
        FCC      "C@"
CFET:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FETCH
        FDB    N_CFET

        LDB   [0,U]          ; Fetch byte pointed to by top of stack
        CLRA                 ; Clear high order byte
        STD   0,U            ; Put word on the top of the stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   2@   *
;  **********
;
N_TFET:   FDB      2
        FCC      "2@"
TFET:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CFET
        FDB    N_TFET

        PULU  X              ; Get pointer
        LDD   2,X            ; Get least significant word
        PSHU  D              ; Push it
        LDD   0,X            ; Get most significant word
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   !   *
;  *********
;
N_STORE:   FDB      1
        FCC      "!"
STORE:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TFET
        FDB    N_STORE

        PULU  X              ; Get address
        PULU  D              ; Get word in D register
        STD   0,X            ; Store word at address
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   C!   *
;  **********
;
N_CSTOR:   FDB      2
        FCC      "C!"
CSTOR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+STORE
        FDB    N_CSTOR

        PULU  X              ; Get address
        PULU  D              ; Get byte in B register
        STB   0,X            ; Store byte at address
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   2!   *
;  **********
;
N_TSTOR:   FDB      2
        FCC      "2!"
TSTOR:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CSTOR
        FDB    N_TSTOR

        PULU  X              ; Get address
        PULU  D              ; Get most significant word
        STD   0,X            ; Store it
        PULU  D              ; Get least significant word
        STD   2,X            ; Store it
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **************
;  *   WITHIN   *
;  **************
;
N_WITHIN:   FDB      6
        FCC      "WITHIN"
WITHIN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TSTOR
        FDB    N_WITHIN

        FDB      OVER, LSUB, TOR
        FDB      LSUB, FROMR
        FDB      ULESS
        FDB      SEMIS
;
;

;  *********
;  *   :   *
;  *********
;
N_COLON:   FDB      1
        FCC      ":"
COLON:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+WITHIN
        FDB    N_COLON

        FDB      SCSP
        FDB      LPWORD
        FDB      PCREAT
        FDB      LATEST, HIDDEN
        FDB      RBRAC
        FDB      PSCOD
DOCOL:  PSHS    Y
        LDY     D_HOFFSET*CW,X   ;(IP) <- (PFA)
;        CALL    DISPLAYSI
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   ;   *
;  *********
;
N_SEMI:   FDB      1
        FCC      ";"
SEMI:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+COLON
        FDB    N_SEMI

        FDB      QCSP
        FDB      LIT, SEMIS, COMMA
        FDB      LATEST, HIDDEN
        FDB      LBRAC
        FDB      SEMIS
;

;  ****************
;  *   CONSTANT   *
;  ****************
;
N_LCONST:   FDB      8
        FCC      "CONSTANT"
LCONST:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SEMI
        FDB    N_LCONST

        FDB      LPWORD
        FDB      PCREAT
        FDB      LATEST, TDFA, STORE
        FDB      PSCOD
DOCON:  LDD     D_HOFFSET-C_HOFFSET*CW,X ;GET DATA FROM PFA
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ****************
;  *   VARIABLE   *
;  ****************
;
N_VAR:   FDB      8
        FCC      "VARIABLE"
VAR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LCONST
        FDB    N_VAR

        FDB      LPWORD
        FDB      PCREAT
        FDB      ZERO, COMMA
        FDB      PSCOD
DOVAR:  LEAX   D_HOFFSET-C_HOFFSET*CW,X
        PSHU    X
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   USER   *
;  ************
;
N_USER:   FDB      4
        FCC      "USER"
USER:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+VAR
        FDB    N_USER

        FDB      LCONST
        FDB      PSCOD
DOUSE:  LDX     D_HOFFSET-C_HOFFSET*CW,X
        LDD     USINI
        LEAX    D,X     ;ADDR OF VARIABLE
        PSHU    X
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;
;

;  *********
;  *   _   *
;  *********
;
N_X:   FDB      1
        FCC      "_"
X:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+USER
        FDB    N_X

        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X] ;Whatever happens to be in D.
;

;  *********
;  *   0   *
;  *********
;
N_ZERO:   FDB      1
        FCC      "0"
ZERO:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+X
        FDB    N_ZERO

        FDB      LIT,0
        FDB      SEMIS
;

;  *********
;  *   1   *
;  *********
;
N_ONE:   FDB      1
        FCC      "1"
ONE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ZERO
        FDB    N_ONE

        FDB      LIT,1
        FDB      SEMIS
;

;  *********
;  *   2   *
;  *********
;
N_TWO:   FDB      1
        FCC      "2"
TWO:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ONE
        FDB    N_TWO

        FDB      LIT,2
        FDB      SEMIS
;

;  **********
;  *   BL   *
;  **********
;
N_LBL:   FDB      2
        FCC      "BL"
LBL:        FDB    DOCON
        FDB    ABL
        FDB    $0
        FDB    -C_HOFFSET*CW+TWO
        FDB    N_LBL

;

;  **********
;  *   $@   *
;  **********
;
N_SFET:   FDB      2
        FCC      "$@"
SFET:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LBL
        FDB    N_SFET

        FDB LDUP, CELLP, SWAP, FETCH
        FDB SEMIS
;

;  **********
;  *   $!   *
;  **********
;
N_SSTOR:   FDB      2
        FCC      "$!"
SSTOR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SFET
        FDB    N_SSTOR

        FDB TDUP, STORE, CELLP, SWAP, LCMOVE
        FDB SEMIS
;

;  *************
;  *   $!-BD   *
;  *************
;
N_SSTORBD:   FDB      5
        FCC      "$!-BD"
SSTORBD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SSTOR
        FDB    N_SSTORBD

        FDB TDUP, CSTOR, ONEP, SWAP, LCMOVE
        FDB SEMIS
;

;  ***********
;  *   $+!   *
;  ***********
;
N_SADD:   FDB      3
        FCC      "$+!"
SADD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SSTORBD
        FDB    N_SADD

        FDB   LDUP, FETCH, TOR ; Remember old count.
        FDB   TDUP, PSTORE
        FDB   CELLP, FROMR, PLUS, SWAP, LCMOVE
        FDB SEMIS
;

;  ***********
;  *   $C+   *
;  ***********
;
N_CHAPP:   FDB      3
        FCC      "$C+"
CHAPP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SADD
        FDB    N_CHAPP

        FDB   LDUP, TOR
        FDB   LDUP, FETCH, PLUS, CELLP, CSTOR
        FDB   ONE, FROMR, PSTORE
        FDB SEMIS
;

;  **********
;  *   $,   *
;  **********
;
N_SCOMMA:   FDB      2
        FCC      "$,"
SCOMMA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CHAPP
        FDB    N_SCOMMA

        FDB HERE, TOR
        FDB LDUP, CELLP, ALLOT
        FDB RR, SSTOR, FROMR
        FDB SEMIS
;
;
;
; THE END  OF THE MEMORY 

;  **********
;  *   EM   *
;  **********
;
N_LEM:   FDB      2
        FCC      "EM"
LEM:        FDB    DOCON
        FDB    ACTUAL_EM
        FDB    $0
        FDB    -C_HOFFSET*CW+SCOMMA
        FDB    N_LEM

;

;  **********
;  *   BM   *
;  **********
;
N_LBM:   FDB      2
        FCC      "BM"
LBM:        FDB    DOCON
        FDB    ORG0
        FDB    $0
        FDB    -C_HOFFSET*CW+LEM
        FDB    N_LBM

;
;
; All user variables are initialised 
; with the values from USINI.
; The implementation relies on the initialisation of 
; those with numbers (1..11), so change in concord with USINI.

;  **********
;  *   U0   *
;  **********
;
N_UZERO:   FDB      2
        FCC      "U0"
UZERO:        FDB    DOUSE
        FDB    1*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LBM
        FDB    N_UZERO

;

;  **********
;  *   S0   *
;  **********
;
N_SZERO:   FDB      2
        FCC      "S0"
SZERO:        FDB    DOUSE
        FDB    2*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+UZERO
        FDB    N_SZERO

;

;  **********
;  *   R0   *
;  **********
;
N_RZERO:   FDB      2
        FCC      "R0"
RZERO:        FDB    DOUSE
        FDB    3*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+SZERO
        FDB    N_RZERO

;

;  ***********
;  *   TIB   *
;  ***********
;
N_TIB:   FDB      3
        FCC      "TIB"
TIB:        FDB    DOUSE
        FDB    4*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+RZERO
        FDB    N_TIB

;

;  **************
;  *   RUBOUT   *
;  **************
;
N_RUBOUT:   FDB      6
        FCC      "RUBOUT"
RUBOUT:        FDB    DOUSE
        FDB    5*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+TIB
        FDB    N_RUBOUT

;

;  ***************
;  *   WARNING   *
;  ***************
;
N_LWARN:   FDB      7
        FCC      "WARNING"
LWARN:        FDB    DOUSE
        FDB    7*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+RUBOUT
        FDB    N_LWARN

;

;  *************
;  *   FENCE   *
;  *************
;
N_FENCE:   FDB      5
        FCC      "FENCE"
FENCE:        FDB    DOUSE
        FDB    8*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LWARN
        FDB    N_FENCE

;

;  **********
;  *   DP   *
;  **********
;
N_LDP:   FDB      2
        FCC      "DP"
LDP:        FDB    DOUSE
        FDB    9*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+FENCE
        FDB    N_LDP

;

;  ****************
;  *   VOC-LINK   *
;  ****************
;
N_VOCL:   FDB      8
        FCC      "VOC-LINK"
VOCL:        FDB    DOUSE
        FDB    10*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LDP
        FDB    N_VOCL

;
;
; End of user variables with fixed place.
;
;

;  *************
;  *   WHERE   *
;  *************
;
N_LWHERE:   FDB      5
        FCC      "WHERE"
LWHERE:        FDB    DOUSE
        FDB    12*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+VOCL
        FDB    N_LWHERE
    ;  Occupies two CELLS! 
;
;

;  *************
;  *   STATE   *
;  *************
;
N_STATE:   FDB      5
        FCC      "STATE"
STATE:        FDB    DOUSE
        FDB    18*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LWHERE
        FDB    N_STATE

;

;  ************
;  *   BASE   *
;  ************
;
N_BASE:   FDB      4
        FCC      "BASE"
BASE:        FDB    DOUSE
        FDB    19*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+STATE
        FDB    N_BASE

;

;  ***********
;  *   DPL   *
;  ***********
;
N_DPL:   FDB      3
        FCC      "DPL"
DPL:        FDB    DOUSE
        FDB    20*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+BASE
        FDB    N_DPL

;

;  ***********
;  *   FLD   *
;  ***********
;
N_LFLD:   FDB      3
        FCC      "FLD"
LFLD:        FDB    DOUSE
        FDB    21*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+DPL
        FDB    N_LFLD

;


;  ***********
;  *   CSP   *
;  ***********
;
N_LCSP:   FDB      3
        FCC      "CSP"
LCSP:        FDB    DOUSE
        FDB    22*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LFLD
        FDB    N_LCSP

;
;
;

;  ***********
;  *   HLD   *
;  ***********
;
N_HLD:   FDB      3
        FCC      "HLD"
HLD:        FDB    DOUSE
        FDB    24*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LCSP
        FDB    N_HLD

;

;  ***********
;  *   OUT   *
;  ***********
;
N_LOUT:   FDB      3
        FCC      "OUT"
LOUT:        FDB    DOUSE
        FDB    25*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+HLD
        FDB    N_LOUT

;
;

;  **********
;  *   IN   *
;  **********
;
N_LIN:   FDB      2
        FCC      "IN"
LIN:        FDB    DOUSE
        FDB    29*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LOUT
        FDB    N_LIN

;


;  *************
;  *   (>IN)   *
;  *************
;
N_PIIN:   FDB      5
        FCC      "(>IN)"
PIIN:        FDB    DOUSE
        FDB    30*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+LIN
        FDB    N_PIIN

;
;

;  ************
;  *   ARGS   *
;  ************
;
N_ARGS:   FDB      4
        FCC      "ARGS"
ARGS:        FDB    DOUSE
        FDB    31*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+PIIN
        FDB    N_ARGS

;

;  ***************
;  *   HANDLER   *
;  ***************
;
N_HANDLER:   FDB      7
        FCC      "HANDLER"
HANDLER:        FDB    DOUSE
        FDB    32*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+ARGS
        FDB    N_HANDLER

;

;  ***************
;  *   CURRENT   *
;  ***************
;
N_CURR:   FDB      7
        FCC      "CURRENT"
CURR:        FDB    DOUSE
        FDB    34*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+HANDLER
        FDB    N_CURR

;

;  *****************
;  *   REMAINDER   *
;  *****************
;
N_REMAIND:   FDB      9
        FCC      "REMAINDER"
REMAIND:        FDB    DOUSE
        FDB    14*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+CURR
        FDB    N_REMAIND

;      IMPORTANT
; REQUIRES ONE MORE CELL!
;

;  ***************
;  *   CONTEXT   *
;  ***************
;
N_CONTEXT:   FDB      7
        FCC      "CONTEXT"
CONTEXT:        FDB    DOUSE
        FDB    37*CW
        FDB    $0
        FDB    -C_HOFFSET*CW+REMAIND
        FDB    N_CONTEXT
 ; Up to  37+8
;      IMPORTANT
;     8 USER SPACE CELLS MUST BE KEPT FREE
;     IN ADDITION TO THE ONE FOR CONTEXT
;
;========== END USER VARIABLES =============;
;

;  **********
;  *   1+   *
;  **********
;
N_ONEP:   FDB      2
        FCC      "1+"
ONEP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CONTEXT
        FDB    N_ONEP

        FDB      ONE
        FDB      PLUS
        FDB      SEMIS
;

;  *************
;  *   CELL+   *
;  *************
;
N_CELLP:   FDB      5
        FCC      "CELL+"
CELLP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ONEP
        FDB    N_CELLP

        FDB      LIT, CW
        FDB      PLUS
        FDB      SEMIS
;

;
;  *************
;  *   CELLS   *
;  *************
;
N_LCELLS:   FDB      5
        FCC      "CELLS"
LCELLS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CELLP
        FDB    N_LCELLS

        FDB      ONE 
        FDB      LSHIFT
        FDB      SEMIS
;

;  *************
;  *   CHAR+   *
;  *************
;
N_CHARP:   FDB      5
        FCC      "CHAR+"
CHARP:        FDB    DOCOL
        FDB    PH_OFFSET-C_HOFFSET*CW+ONEP
        FDB    $0
        FDB    -C_HOFFSET*CW+LCELLS
        FDB    N_CHARP

;

;  *************
;  *   CHARS   *
;  *************
;
N_CHARS:   FDB      5
        FCC      "CHARS"
CHARS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+CHARP
        FDB    N_CHARS

        FDB      SEMIS
;

;  *************
;  *   ALIGN   *
;  *************
;
N_LALIGN:   FDB      5
        FCC      "ALIGN"
LALIGN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+CHARS
        FDB    N_LALIGN

        FDB      SEMIS
;

;  ***************
;  *   ALIGNED   *
;  ***************
;
N_ALIGNED:   FDB      7
        FCC      "ALIGNED"
ALIGNED:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LALIGN
        FDB    N_ALIGNED

        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   HERE   *
;  ************
;
N_HERE:   FDB      4
        FCC      "HERE"
HERE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ALIGNED
        FDB    N_HERE

        FDB      LDP
        FDB      FETCH
        FDB      SEMIS
;

;  *************
;  *   ALLOT   *
;  *************
;
N_ALLOT:   FDB      5
        FCC      "ALLOT"
ALLOT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+HERE
        FDB    N_ALLOT

        FDB      LDP
        FDB      PSTORE
        FDB      SEMIS
;

;  *********
;  *   ,   *
;  *********
;
N_COMMA:   FDB      1
        FCC      ","
COMMA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ALLOT
        FDB    N_COMMA

        FDB      HERE
        FDB      STORE
        FDB      TWO
        FDB      ALLOT
        FDB      SEMIS
;

;  **********
;  *   C,   *
;  **********
;
N_CCOMM:   FDB      2
        FCC      "C,"
CCOMM:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+COMMA
        FDB    N_CCOMM

        FDB      HERE
        FDB      CSTOR
        FDB      ONE
        FDB      ALLOT
        FDB      SEMIS
;

;  *********
;  *   -   *
;  *********
;
N_LSUB:   FDB      1
        FCC      "-"
LSUB:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CCOMM
        FDB    N_LSUB

        LDD   2,U            ; Get first value
        SUBD  0,U            ; Do subtraction
        LEAU  2,U            ; Adjust stack
        STD   0,U            ; Put difference on top of stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   =   *
;  *********
;
N_EQUAL:   FDB      1
        FCC      "="
EQUAL:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LSUB
        FDB    N_EQUAL

        FDB      LSUB
        FDB      ZEQU
        FDB      SEMIS
;

;  *********
;  *   <   *
;  *********
;
N_LESS:   FDB      1
        FCC      "<"
LESS:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+EQUAL
        FDB    N_LESS

        PULU  D              ; Get top of stack
        LDX   #0             ; Assume a FALSE
        CMPD  0,U            ; Compare with new top of stack
        BLE   LESS1          ; Yes it is FALSE
        LEAX  -1,X            ; No it is TRUE
LESS1   STX   0,U            ; Leave flag on the stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   U<   *
;  **********
;
N_ULESS:   FDB      2
        FCC      "U<"
ULESS:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LESS
        FDB    N_ULESS

        PULU  D              ; Get top of stack
        LDX   #0             ; Assume a FALSE
        CMPD  0,U            ; Compare with new top of stack
        BLS   ULESS1          ; Yes it is FALSE
        LEAX  -1,X            ; No it is TRUE
ULESS1   STX   0,U            ; Leave flag on the stack
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *********
;  *   >   *
;  *********
;
N_GREAT:   FDB      1
        FCC      ">"
GREAT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ULESS
        FDB    N_GREAT

        FDB      SWAP
        FDB      LESS
        FDB      SEMIS
;

;  **********
;  *   <>   *
;  **********
;
N_UNEQ:   FDB      2
        FCC      "<>"
UNEQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+GREAT
        FDB    N_UNEQ

        FDB      LSUB
        FDB      ZEQU
        FDB      ZEQU
        FDB      SEMIS
;

;  ***********
;  *   ROT   *
;  ***********
;
N_ROT:   FDB      3
        FCC      "ROT"
ROT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+UNEQ
        FDB    N_ROT

        PSHS  Y            ;  HIP (Y) is needed here.
        PULU  D,X,Y          ; S1 in D, S2 in X, S3 in Y
        PSHU  D,X            ; Put S1 and S2 back on stack
        PSHU  Y              ; Put S3 on top of stack
        PULS  Y              ; Restore IP
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *************
;  *   SPACE   *
;  *************
;
N_SPACE:   FDB      5
        FCC      "SPACE"
SPACE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ROT
        FDB    N_SPACE

        FDB      LBL
        FDB      EMIT
        FDB      SEMIS
;

;  ************
;  *   ?DUP   *
;  ************
;
N_QDUP:   FDB      4
        FCC      "?DUP"
QDUP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SPACE
        FDB    N_QDUP

        FDB      LDUP
        FDB      ZBRAN
        FDB      QDUP1-*-CW ; IF
        FDB      LDUP    ;THEN
QDUP1:  FDB      SEMIS
;

;  **************
;  *   LATEST   *
;  **************
;
N_LATEST:   FDB      6
        FCC      "LATEST"
LATEST:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QDUP
        FDB    N_LATEST

        FDB      CURR
        FDB      FETCH
        FDB      TLFA
        FDB      FETCH
        FDB      SEMIS
;

;  ************
;  *   >CFA   *
;  ************
;
N_TCFA:   FDB      4
        FCC      ">CFA"
TCFA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LATEST
        FDB    N_TCFA

        FDB      LIT, C_HOFFSET*CW
        FDB      PLUS
        FDB      SEMIS
;

;  ************
;  *   >DFA   *
;  ************
;
N_TDFA:   FDB      4
        FCC      ">DFA"
TDFA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TCFA
        FDB    N_TDFA

        FDB      LIT, D_HOFFSET*CW
        FDB      PLUS
        FDB      SEMIS
;

;  ************
;  *   >FFA   *
;  ************
;
N_TFFA:   FDB      4
        FCC      ">FFA"
TFFA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TDFA
        FDB    N_TFFA

        FDB      LIT, F_HOFFSET*CW
        FDB      PLUS
        FDB      SEMIS
;

;  ************
;  *   >LFA   *
;  ************
;
N_TLFA:   FDB      4
        FCC      ">LFA"
TLFA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TFFA
        FDB    N_TLFA

        FDB      LIT, L_HOFFSET*CW
        FDB      PLUS
        FDB      SEMIS
;

;  ************
;  *   >NFA   *
;  ************
;
N_TNFA:   FDB      4
        FCC      ">NFA"
TNFA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TLFA
        FDB    N_TNFA

        FDB      LIT,N_HOFFSET*CW
        FDB      PLUS
        FDB      SEMIS
;
;

;  ************
;  *   >PHA   *
;  ************
;
N_TPHA:   FDB      4
        FCC      ">PHA"
TPHA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TNFA
        FDB    N_TPHA

        FDB      LIT,PH_OFFSET*CW
        FDB      PLUS
        FDB      SEMIS
;

;  *************
;  *   >BODY   *
;  *************
;
N_TOBODY:   FDB      5
        FCC      ">BODY"
TOBODY:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TPHA
        FDB    N_TOBODY

        FDB      CTOD
        FDB      TDFA, FETCH
        FDB      CELLP           ; Skip DOES> pointer.
        FDB      SEMIS
;

;  *************
;  *   BODY>   *
;  *************
;
N_BODYF:   FDB      5
        FCC      "BODY>"
BODYF:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TOBODY
        FDB    N_BODYF

        FDB      LIT,BD_OFFSET*CW
        FDB      LSUB
        FDB      SEMIS
;

;  ************
;  *   CFA>   *
;  ************
;
N_CTOD:   FDB      4
        FCC      "CFA>"
CTOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BODYF
        FDB    N_CTOD

        FDB      LIT,C_HOFFSET*CW
        FDB      LSUB
        FDB      SEMIS
;

;  ************
;  *   >WID   *
;  ************
;
N_TWID:   FDB      4
        FCC      ">WID"
TWID:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CTOD
        FDB    N_TWID

        FDB      TOBODY
        FDB      CELLP ; Skip vfa link.
        FDB      SEMIS
;

;  ************
;  *   >VFA   *
;  ************
;
N_TVFA:   FDB      4
        FCC      ">VFA"
TVFA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TWID
        FDB    N_TVFA

        FDB      TOBODY
        FDB      SEMIS
;


;  ************
;  *   !CSP   *
;  ************
;
N_SCSP:   FDB      4
        FCC      "!CSP"
SCSP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TVFA
        FDB    N_SCSP

        FDB      SPFET
        FDB      LCSP
        FDB      STORE
        FDB      SEMIS
;
;

;  **************
;  *   ?ERROR   *
;  **************
;
N_QERR:   FDB      6
        FCC      "?ERROR"
QERR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SCSP
        FDB    N_QERR

        FDB      SWAP
        FDB      ZBRAN
        FDB      QERR1-*-CW ;IF
        FDB      LIN, FETCH
        FDB      SRC, FETCH
        FDB      LWHERE, TSTOR
        FDB      THROW
        FDB      BRAN
        FDB      QERR2-*-CW  ;ELSE
QERR1:  FDB      DROP    ;THEN
QERR2:  FDB      SEMIS
;


;  **************
;  *   ?DELIM   *
;  **************
;
N_QDELIM:   FDB      6
        FCC      "?DELIM"
QDELIM:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QERR
        FDB    N_QDELIM

        FDB      INBRS
        FDB      QBL
        FDB      ZEQU
        FDB      LIT, 10, QERR
        FDB      DROP
        FDB      SEMIS
;

;  ************
;  *   ?CSP   *
;  ************
;
N_QCSP:   FDB      4
        FCC      "?CSP"
QCSP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QDELIM
        FDB    N_QCSP

        FDB      SPFET
        FDB      LCSP
        FDB      FETCH
        FDB      LSUB
        FDB      LIT, 20, QERR
        FDB      SEMIS
;

;  *************
;  *   ?COMP   *
;  *************
;
N_QCOMP:   FDB      5
        FCC      "?COMP"
QCOMP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QCSP
        FDB    N_QCOMP

        FDB      STATE
        FDB      FETCH
        FDB      ZEQU
        FDB      LIT, 17, QERR
        FDB      SEMIS
;

;  *************
;  *   ?EXEC   *
;  *************
;
N_QEXEC:   FDB      5
        FCC      "?EXEC"
QEXEC:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QCOMP
        FDB    N_QEXEC

        FDB      STATE
        FDB      FETCH
        FDB      LIT, 18, QERR
        FDB      SEMIS
;

;  **************
;  *   ?PAIRS   *
;  **************
;
N_QPAIR:   FDB      6
        FCC      "?PAIRS"
QPAIR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QEXEC
        FDB    N_QPAIR

        FDB      LSUB
        FDB      LIT, 19, QERR
        FDB      SEMIS
;
;
;
;

;  *********
;  *   [   *
;  *********
;
N_LBRAC:   FDB      1
        FCC      "["
LBRAC:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+QPAIR
        FDB    N_LBRAC

        FDB      ZERO
        FDB      STATE
        FDB      STORE
        FDB      SEMIS
;

;  *********
;  *   ]   *
;  *********
;
N_RBRAC:   FDB      1
        FCC      "]"
RBRAC:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LBRAC
        FDB    N_RBRAC

        FDB      ONE
        FDB      STATE
        FDB      STORE
        FDB      SEMIS
;

;  **************
;  *   HIDDEN   *
;  **************
;
N_HIDDEN:   FDB      6
        FCC      "HIDDEN"
HIDDEN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RBRAC
        FDB    N_HIDDEN

        FDB      TFFA
        FDB      LIT,B_INVIS
        FDB      TOGGL
        FDB      SEMIS
;

;  ***********
;  *   HEX   *
;  ***********
;
N_HEX:   FDB      3
        FCC      "HEX"
HEX:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+HIDDEN
        FDB    N_HEX

        FDB      LIT,16
        FDB      BASE
        FDB      STORE
        FDB      SEMIS
;

;  ***************
;  *   DECIMAL   *
;  ***************
;
N_DECA:   FDB      7
        FCC      "DECIMAL"
DECA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+HEX
        FDB    N_DECA

        FDB      LIT,10
        FDB      BASE
        FDB      STORE
        FDB      SEMIS
;

;  ***************
;  *   (;CODE)   *
;  ***************
;
N_PSCOD:   FDB      7
        FCC      "(;CODE)"
PSCOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DECA
        FDB    N_PSCOD

        FDB      FROMR
        FDB      LATEST
        FDB      TCFA
        FDB      STORE
        FDB      SEMIS
;

;

;  **************
;  *   CREATE   *
;  **************
;
N_CREATE:   FDB      6
        FCC      "CREATE"
CREATE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PSCOD
        FDB    N_CREATE

        FDB      LPWORD
        FDB      PCREAT
        FDB      LIT, HLNOOP, COMMA
        FDB      PSCOD
DODOE:  PSHS    Y
        LDY     D_HOFFSET-C_HOFFSET*CW,X  ;NEW IP 
        LEAX    CW,Y
        LDY     ,Y
        PSHU    X
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
HLNOOP: FDB      SEMIS
;

;  *************
;  *   DOES>   *
;  *************
;
N_DOES:   FDB      5
        FCC      "DOES>"
DOES:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CREATE
        FDB    N_DOES

        FDB      FROMR
        FDB      LATEST
        FDB      TDFA
        FDB      FETCH
        FDB      STORE
        FDB      SEMIS
;

;  *************
;  *   COUNT   *
;  *************
;
N_COUNT:   FDB      5
        FCC      "COUNT"
COUNT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DOES
        FDB    N_COUNT

        FDB      LDUP
        FDB      ONEP
        FDB      SWAP
        FDB      CFET
        FDB      SEMIS
;

;  *****************
;  *   -TRAILING   *
;  *****************
;
N_DTRAI:   FDB      9
        FCC      "-TRAILING"
DTRAI:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+COUNT
        FDB    N_DTRAI

        FDB      LDUP
        FDB      ZERO
        FDB     XQDO
        FDB      DTRA4-*-CW
DTRA1:  FDB      OVER
        FDB      OVER
        FDB      PLUS
        FDB      ONE
        FDB      LSUB
        FDB      CFET
        FDB      QBL
        FDB      ZEQU
        FDB      ZBRAN
        FDB      DTRA2-*-CW ;IF
        FDB      LLEAV
DTRA2:  FDB      ONE
        FDB      LSUB    ; THEN
        FDB     XLOOP
        FDB      DTRA1-*-CW    ; LOOP
DTRA4:
        FDB      SEMIS
;


;  **********
;  *   S"   *
;  **********
;
N_SQUOT:   FDB      2
        FCC      'S"'
SQUOT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+DTRAI
        FDB    N_SQUOT

        FDB      DENQ
        FDB      SEMIS
;
;

;  **********
;  *   ."   *
;  **********
;
N_DOTQ:   FDB      2
        FCC      '."'
DOTQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+SQUOT
        FDB    N_DOTQ

        FDB      DENQ
        FDB      STATE
        FDB      FETCH
        FDB      ZBRAN
        FDB      DOTQ1-*-CW ; IF
        FDB      LIT, LTYPE, COMMA
        FDB      BRAN
        FDB      DOTQ2-*-CW
DOTQ1:
        FDB      LTYPE
DOTQ2:
        FDB      SEMIS   ; THEN
;

;  **********
;  *   .(   *
;  **********
;
N_DOTP:   FDB      2
        FCC      ".("
DOTP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+DOTQ
        FDB    N_DOTP

        FDB      LIT, ARC
        FDB      PPARS
        FDB      LTYPE
        FDB      SEMIS
;

;  ***************
;  *   SET-SRC   *
;  ***************
;
N_SETSRC:   FDB      7
        FCC      "SET-SRC"
SETSRC:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DOTP
        FDB    N_SETSRC

        FDB      OVER, PLUS
        FDB      SWAP, SRC, TSTOR
        FDB      SRC, FETCH
        FDB      LIN, STORE ;  IN

;       FDB      DOTS
        FDB      SEMIS
;

;  ****************
;  *   EVALUATE   *
;  ****************
;
N_EVALUATE:   FDB      8
        FCC      "EVALUATE"
EVALUATE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SETSRC
        FDB    N_EVALUATE

        FDB      SAVE
        FDB      SETSRC
        FDB      LIT, INTER, CATCH
        FDB      RESTO
        FDB      THROW
        FDB      SEMIS
;

;  ************
;  *   FILL   *
;  ************
;
N_FILL:   FDB      4
        FCC      "FILL"
FILL:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+EVALUATE
        FDB    N_FILL

        PSHS  Y              ; Save IP
        PULU  D,X,Y          ; Character in B, count in X, address in Y
        LEAX  0,X           ; Gracefully handle zero count.
        BEQ   FILL2
FILL1   STB   ,Y+            ; Store character
        LEAX  -1,X           ; Decrement counter
        BNE   FILL1          ; Loop until done
FILL2:  PULS  Y              ; Get IP
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  ************
;  *   CORA   *
;  ************
;
N_CORA:   FDB      4
        FCC      "CORA"
CORA:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FILL
        FDB    N_CORA

    PSHS  Y              ; Save the instruction pointer (Y).
    PULU  D              ; Get the count
    ADDD  0,U            ; Add it to the destination address
    PULU  X,Y            ; Destination in X, Source in Y
    PSHU  D              ; Put end addr. on stack
    BRA CORA2
CORA1:
    LDB   ,Y+            ; Do the compare
    SUBB  ,X+
    BNE   CORA3
CORA2:
    CMPX  0,U            ; At the final destination?
    BLO   CORA1          ; If not, continue
    CLRB              ; Essential for zero length only.
    BRA   CORA4
CORA3:
    SEX
    TFR   A,B
    LSLB              ; -1/0  --> -2/0
    INCB              ; -2/0  --> -1/+1
CORA4:
    SEX
CORA5:
    STD   0,U            ; Overwrite final destination with result.
    PULS  Y              ; Restore the instruction pointer
    LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   $I   *
;  **********
;
N_SINDEX:   FDB      2
        FCC      "$I"
SINDEX:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CORA
        FDB    N_SINDEX

        PSHS    Y
        PULU    D,X,Y   ; char, count, addr
        LEAX    0,X     ; test X for 0.
        BEQ     SIND2
SIND1:
        CMPB    ,Y+
        BEQ     SIND3
        LEAX    -1,X
        BNE     SIND1
SIND2:
        PSHU    X       ; I.e. nil pointer.
        BRA     SIND4
SIND3:
        LEAY    -1,Y
        PSHU    Y
SIND4:
        PULS    Y
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   $S   *
;  **********
;
N_SSPLIT:   FDB      2
        FCC      "$S"
SSPLIT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SINDEX
        FDB    N_SSPLIT

        PSHS    Y
        PULU    D,X,Y   ; char, count, addr
        PSHU    Y,X   ; Start + place holder. 
        PSHU    Y,X   ; Default if not found.
        LEAX    0,X       ; Handle count of 
        BEQ     SSPLI2   ;   zero gracefully. 
SSPLI1:
        CMPB    ,Y+
        BEQ     SSPLI3
        LEAX    -1,X
        BNE     SSPLI1
SSPLI2:
; Not present.
        STX     4,U     ;Remainder is null.
        STX     6,U
        BRA SSPLI9
SSPLI3:
        STY     6,U     ;Start of remainder
        LEAX    -1,X
        STX     4,U     ;Length of remainder
        LDD     ,U      ;Original string length. 
        SUBD    4,U
        ADDD    #-1     ;Exclude delimiter.
        STD     ,U      ;Length before delimiter.
SSPLI9:
        PULS    Y
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  *************
;  *   ERASE   *
;  *************
;
N_LERASE:   FDB      5
        FCC      "ERASE"
LERASE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SSPLIT
        FDB    N_LERASE

        FDB      ZERO
        FDB      FILL
        FDB      SEMIS
;


;  *************
;  *   BLANK   *
;  *************
;
N_BLANK:   FDB      5
        FCC      "BLANK"
BLANK:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LERASE
        FDB    N_BLANK

        FDB      LBL
        FDB      FILL
        FDB      SEMIS
;
;

;  ************
;  *   HOLD   *
;  ************
;
N_HOLD:   FDB      4
        FCC      "HOLD"
HOLD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BLANK
        FDB    N_HOLD

        FDB      LIT,-1
        FDB      HLD
        FDB      PSTORE
        FDB      HLD
        FDB      FETCH
        FDB      CSTOR
        FDB      SEMIS
;

;  ***********
;  *   PAD   *
;  ***********
;
N_PAD:   FDB      3
        FCC      "PAD"
PAD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+HOLD
        FDB    N_PAD

        FDB      HERE
; Allow for a one line name, a double binary number and some hold char's
        FDB      LIT,84+128+64
        FDB      PLUS
        FDB      SEMIS
;


;  ************
;  *   WORD   *
;  ************
;
N_IWORD:   FDB      4
        FCC      "WORD"
IWORD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PAD
        FDB    N_IWORD

        FDB      LDUP, LBL, EQUAL
        FDB      ZBRAN
        FDB      IWORD1-*-CW
         FDB      DROP
         FDB      LPWORD
        FDB      BRAN
        FDB      IWORD2-*-CW
IWORD1: FDB      TOR
IWORD3:  FDB      INBRS, RR, EQUAL
        FDB      ZBRAN
        FDB      IWORD4-*-CW
        FDB      DROP
        FDB      BRAN
        FDB      IWORD3-*-CW
IWORD4:
        FDB      DROP
        FDB      LIT, -1, LIN, PSTORE ; Backtrace to first non-delimiter.
        FDB      FROMR, PPARS
;        FDB      DOTS
IWORD2:
        FDB      HERE
        FDB      LIT,$22
        FDB      BLANK
        FDB      HERE
        FDB      SSTORBD     ; FIXME
        FDB      HERE
;        FDB      DOTS
        FDB      SEMIS
;
;

;  ************
;  *   CHAR   *
;  ************
;
N_LCHAR:   FDB      4
        FCC      "CHAR"
LCHAR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+IWORD
        FDB    N_LCHAR

        FDB      LPWORD, DROP, CFET
        FDB      SEMIS
;

;  **************
;  *   [CHAR]   *
;  **************
;
N_BCHAR:   FDB      6
        FCC      "[CHAR]"
BCHAR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+LCHAR
        FDB    N_BCHAR

        FDB      LCHAR, LITER
        FDB      SEMIS
;

;  ****************
;  *   (NUMBER)   *
;  ****************
;
N_PNUMB:   FDB      8
        FCC      "(NUMBER)"
PNUMB:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BCHAR
        FDB    N_PNUMB

        FDB      ZERO, ZERO
        FDB      ZERO, DPL, STORE
NPNUM1:  FDB      INBRS   ; BEGIN
        FDB      LDUP, LIT, ADOT, EQUAL
        FDB      ZBRAN
        FDB      NPNUM2A-*-CW ; IF
        FDB      DROP, DPL, STORE, ZERO
        FDB      BRAN
        FDB      NPNUM3-*-CW ; ELSE
NPNUM2A:
        FDB      LDUP, LIT, ACM, EQUAL
        FDB      ZBRAN
        FDB      NPNUM2-*-CW ; IF
        FDB      TDROP, ZERO
        FDB      BRAN
        FDB      NPNUM3-*-CW ; ELSE
NPNUM2:
        FDB      LDUP, QBL
        FDB      ZBRAN
        FDB      NPNUM4-*-CW ; IF
        FDB      DROP, DROP, ONE
        FDB      BRAN
        FDB      NPNUM3-*-CW ; ELSE
NPNUM4:
        FDB      SWAP, DROP
        FDB      BASE, FETCH, DIGIT
        FDB      ZEQU
        FDB      LIT, 10, QERR

        FDB      SWAP
        FDB      BASE
        FDB      FETCH
        FDB      USTAR
        FDB      DROP
        FDB      ROT
        FDB      BASE
        FDB      FETCH
        FDB      USTAR
        FDB      DPLUS
        FDB      ZERO
NPNUM3:                 ; THEN THEN
        FDB      ZBRAN
        FDB      NPNUM1-*-CW
        FDB      SEMIS
;

;  **************
;  *   NUMBER   *
;  **************
;
N_NUMB:   FDB      6
        FCC      "NUMBER"
NUMB:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PNUMB
        FDB    N_NUMB

LNUMB:
        FDB      LIT, -1, LIN, PSTORE
        FDB      PNUMB, SDLITE
        FDB      SEMIS
;


;  ***************
;  *   >NUMBER   *
;  ***************
;
N_TONUMB:   FDB      7
        FCC      ">NUMBER"
TONUMB:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+NUMB
        FDB    N_TONUMB

        FDB      TDUP, PLUS, TOR     ; End available on return stack.
        FDB      ZERO
        FDB     XQDO
        FDB      TONUM9-*-CW
TONUM1:
        FDB      LDUP, CFET, BASE, FETCH, DIGIT
        FDB      ZEQU
        FDB      ZBRAN
        FDB      TONUM4-*-CW ; IF
        FDB      DROP
        FDB      LLEAV
TONUM4:
        FDB      SWAP, TOR ; Address out of the way.
        FDB      SWAP
        FDB      BASE
        FDB      FETCH
        FDB      USTAR
        FDB      DROP
        FDB      ROT
        FDB      BASE
        FDB      FETCH
        FDB      USTAR
        FDB      DPLUS
        FDB      FROMR, ONEP     ; Address back.
        FDB     XLOOP
        FDB      TONUM1-*-CW
TONUM9:
        FDB      FROMR
        FDB      OVER, LSUB
        FDB      SEMIS
;
;

;  *************
;  *   FOUND   *
;  *************
;
N_FOUND:   FDB      5
        FCC      "FOUND"
FOUND:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TONUMB
        FDB    N_FOUND

        FDB      CONTEXT, TOR
FOUND1: FDB      RR, FETCH
;        FDB      DOTS
        FDB      PFIND, LDUP, ZEQU
        FDB      ZBRAN
        FDB      FOUND3-*-CW
        FDB      DROP
        FDB      RR, FETCH, LIT, FORTH, LSUB ;Was this ONLY?
        FDB      ZBRAN
        FDB      FOUND2-*-CW
        FDB      FROMR, CELLP, TOR
        FDB      BRAN
        FDB      FOUND1-*-CW
FOUND2: FDB      ZERO
FOUND3: FDB      RDROP
        FDB      SWAP,DROP,SWAP,DROP
        FDB      SEMIS
;

;  ***************
;  *   PRESENT   *
;  ***************
;
N_PRESENT:   FDB      7
        FCC      "PRESENT"
PRESENT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FOUND
        FDB    N_PRESENT

        FDB      LDUP, TOR
        FDB      FOUND
        FDB      LDUP
        FDB      ZBRAN
        FDB      PRES1-*-CW
        FDB      LDUP
        FDB      TNFA, FETCH, FETCH ;  Get precise length.
        FDB      RR, EQUAL
        FDB      LAND
PRES1:
        FDB      RDROP
        FDB      SEMIS
;


;  ************
;  *   FIND   *
;  ************
;
N_FIND:   FDB      4
        FCC      "FIND"
FIND:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PRESENT
        FDB    N_FIND

        FDB      LDUP, COUNT, PRESENT
        FDB      LDUP
        FDB      ZBRAN
        FDB      FIND1-*-CW ;IF
        FDB      SWAP, DROP ; The address.
        ; Fine point, get xt by TCFA. Even if a NOOP.
        FDB      LDUP, TCFA, SWAP
        FDB      TFFA, FETCH
        FDB      LIT, B_IMMED, LAND
        FDB      LIT, -1, SWAP
        FDB      ZBRAN
        FDB      FIND1-*-CW ;IF
        FDB      NEGATE
FIND1:               ;THEN THEN
        FDB      SEMIS
;

;  **************
;  *   (FIND)   *
;  **************
;
N_PFIND:   FDB      6
        FCC      "(FIND)"
PFIND:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FIND
        FDB    N_PFIND

PFIND0:
        FDB      LDUP
        FDB      ZBRAN
        FDB      PFIND1-*-CW
        FDB      PMATCH, ZEQU
        FDB      ZBRAN
        FDB      PFIND1-*-CW
        FDB     TLFA, FETCH
        FDB      BRAN
        FDB      PFIND0-*-CW
PFIND1:
        FDB      SEMIS
;

;  *************
;  *   ERROR   *
;  *************
;
N_ERROR:   FDB      5
        FCC      "ERROR"
ERROR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PFIND
        FDB    N_ERROR

        FDB      LWHERE, TFET
        FDB      OVER, LIT, 20, LSUB
        FDB      MAX
        FDB      SWAP,OVER, LSUB
        FDB      ETYPE
        FDB      SKIP
         FDB      18
SB3: FCC      "? ciforth ERROR # "
       
        FDB      LIT, SB3
        FDB      LIT, 18
        FDB      ETYPE
        FDB      BASE, FETCH
        FDB      DECA
        FDB      OVER
        FDB      STOD, ZERO, PDDOTR, ETYPE
        FDB      BASE, STORE
        FDB      DROP
        FDB      SEMIS
;

;  *************
;  *   ETYPE   *
;  *************
;
N_ETYPE:   FDB      5
        FCC      "ETYPE"
ETYPE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ERROR
        FDB    N_ETYPE

        FDB      LTYPE
        FDB      SEMIS
;

;  *************
;  *   CATCH   *
;  *************
;
N_CATCH:   FDB      5
        FCC      "CATCH"
CATCH:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ETYPE
        FDB    N_CATCH

        FDB      SPFET, CELLP, TOR
        FDB      HANDLER, FETCH, TOR
        FDB      RPFET, HANDLER, STORE
        FDB      EXEC
        FDB      FROMR, HANDLER, STORE
        FDB      RDROP, ZERO
        FDB      SEMIS
;

;  *************
;  *   THROW   *
;  *************
;
N_THROW:   FDB      5
        FCC      "THROW"
THROW:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+CATCH
        FDB    N_THROW

        FDB      LDUP
        FDB      ZBRAN
        FDB      THROW1-*-CW
        FDB      HANDLER, FETCH, ZEQU
        FDB      ZBRAN
        FDB      THROW2-*-CW
        FDB      ERROR
                FDB      SZERO, FETCH, SPSTO
        FDB      QUIT
THROW2:
        FDB      HANDLER, FETCH, RPSTO
        FDB      FROMR, HANDLER, STORE
        FDB      FROMR, SWAP, TOR
        FDB      SPSTO
        FDB      FROMR
        FDB      X
THROW1:
        FDB      DROP
        FDB      SEMIS
;


;  ****************
;  *   (ABORT")   *
;  ****************
;
N_PABORTQ:   FDB      8
        FCC      '(ABORT")'
PABORTQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+THROW
        FDB    N_PABORTQ

        FDB      ROT
        FDB      ZBRAN
        FDB      PABQ1-*-CW ;IF
        FDB      ETYPE
        FDB      SIGNON, ABORT
        FDB      BRAN
        FDB      PABQ2-*-CW ;ELSE
PABQ1:  FDB       TDROP
PABQ2:   FDB      SEMIS
;

;  **************
;  *   ABORT"   *
;  **************
;
N_ABORTQ:   FDB      6
        FCC      'ABORT"'
ABORTQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+PABORTQ
        FDB    N_ABORTQ

        FDB      QCOMP
        FDB      DENQ
        FDB      LIT, PABORTQ, COMMA
        FDB      SEMIS
;
;

;  ***********
;  *   ID.   *
;  ***********
;
N_IDDOT:   FDB      3
        FCC      "ID."
IDDOT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ABORTQ
        FDB    N_IDDOT

        FDB      LDUP, TFFA
        FDB      FETCH, LIT, B_DUMMY, LXOR
        FDB      ZBRAN
        FDB      IDDOT1-*-CW
        FDB      TNFA
        FDB      FETCH
        FDB      SFET
        FDB      LTYPE
        FDB      SPACE
        FDB      SPACE
        FDB      SPACE
        FDB      BRAN
        FDB      IDDOT2-*-CW
IDDOT1:
        FDB      DROP
IDDOT2:
        FDB      SEMIS
;

;  ****************
;  *   (CREATE)   *
;  ****************
;
N_PCREAT:   FDB      8
        FCC      "(CREATE)"
PCREAT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+IDDOT
        FDB    N_PCREAT

        FDB      LDUP
        FDB      ZEQU
        FDB      LIT, 5, QERR
        FDB      TDUP
        FDB      PRESENT
        FDB      LDUP
        FDB      ZBRAN
        FDB      CREA1-*-CW ;IF
        FDB      TNFA, FETCH, SFET
        FDB      ETYPE
                FDB      X       ;THEN
CREA1:  FDB      DROP
        FDB      SCOMMA
        FDB      HERE,TOR

        FDB      RR, TPHA, COMMA         ; Code field.

        FDB      RR, TPHA, COMMA         ; Data field.

        FDB      ZERO, COMMA ; Flag field.

        FDB      CURR, FETCH, TLFA
        FDB      LDUP, FETCH, COMMA   ; Link field.
        FDB      RR, SWAP, STORE

        FDB      COMMA   ; Name field.

        FDB      RDROP
        FDB      SEMIS
;

;  *****************
;  *   [COMPILE]   *
;  *****************
;
N_BCOMP:   FDB      9
        FCC      "[COMPILE]"
BCOMP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+PCREAT
        FDB    N_BCOMP

        FDB      LPWORD
        FDB      PRESENT
        FDB      LDUP
        FDB      ZEQU
        FDB      LIT, 16, QERR
        FDB      TCFA
        FDB      COMMA
        FDB      SEMIS
;

;  ****************
;  *   POSTPONE   *
;  ****************
;
N_POSTP:   FDB      8
        FCC      "POSTPONE"
POSTP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+BCOMP
        FDB    N_POSTP

        FDB      LPWORD
        FDB      PRESENT
        FDB      LDUP
        FDB      ZEQU
        FDB      LIT, 15, QERR
        FDB      LDUP, TFFA, FETCH
        FDB      LIT, B_IMMED, LAND, ZEQU
        FDB      ZBRAN
        FDB      POSTP1-*-CW
         FDB      LIT, LIT, COMMA
         FDB      COMMA
         FDB      LIT, COMMA, COMMA
        FDB      BRAN
        FDB      POSTP2-*-CW
POSTP1:
         FDB      COMMA
POSTP2:
        FDB      SEMIS
;

;  ***************
;  *   LITERAL   *
;  ***************
;
N_LITER:   FDB      7
        FCC      "LITERAL"
LITER:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+POSTP
        FDB    N_LITER

        FDB      STATE
        FDB      FETCH
        FDB      ZBRAN
        FDB      LITE1-*-CW ;IF
        FDB      LIT, LIT, COMMA
        FDB      COMMA   ;THEN
LITE1:  FDB      SEMIS
;

;  ****************
;  *   DLITERAL   *
;  ****************
;
N_DLITE:   FDB      8
        FCC      "DLITERAL"
DLITE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+LITER
        FDB    N_DLITE

        FDB      STATE
        FDB      FETCH
        FDB      ZBRAN
        FDB      DLIT1-*-CW ; IF
        FDB      SWAP
        FDB      LITER
        FDB      LITER   ; THEN
DLIT1:  FDB      SEMIS
;
;

;  *****************
;  *   SDLITERAL   *
;  *****************
;
N_SDLITE:   FDB      9
        FCC      "SDLITERAL"
SDLITE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+DLITE
        FDB    N_SDLITE

        FDB      DPL
        FDB      FETCH
        FDB      ZBRAN
        FDB      SDLIT1-*-CW ; IF
        FDB      DLITE
        FDB      BRAN
        FDB      SDLIT2-*-CW ; IF
SDLIT1:
        FDB      DROP, LITER
SDLIT2:
        FDB      SEMIS
;


;  **************
;  *   ?STACK   *
;  **************
;
N_QSTAC:   FDB      6
        FCC      "?STACK"
QSTAC:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SDLITE
        FDB    N_QSTAC

        FDB      SPFET
        FDB      SZERO
        FDB      FETCH
        FDB      SWAP
        FDB      ULESS
        FDB      ONE, QERR
        FDB      SPFET
        FDB      HERE
        FDB      LIT,$80
        FDB      PLUS
        FDB      ULESS
        FDB      LIT, 7, QERR
        FDB      SEMIS
        ;
;
;

;  *****************
;  *   INTERPRET   *
;  *****************
;
N_INTER:   FDB      9
        FCC      "INTERPRET"
INTER:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QSTAC
        FDB    N_INTER

INTE1:
        FDB      LPWORD
        FDB      LDUP      ; Zero length.
        FDB      ZBRAN
        FDB      INTE8-*-CW ;WHILE
;       FDB      DOTS
;       FDB      TDUP, LTYPE
        FDB      OVER, TOR       ; Save old parse pointer.
        FDB      FOUND
        FDB      LDUP, ZEQU
        FDB      LIT, 12, QERR
        FDB      LDUP, TFFA, FETCH
        FDB      LDUP, LIT, B_DENOT, LAND ;Retain copy of flags.
        FDB      ZBRAN
        FDB      INTE3B-*-CW ;IF
        FDB      OVER, TNFA, FETCH, FETCH
        FDB      RR, PLUS, LIN, STORE  ;Skip over prefix.
INTE3B:                  ;THEN 
        FDB      RDROP           ; Drop old parse pointer.
        FDB      LIT, B_IMMED, LAND
        FDB      STATE, FETCH, ZEQU, LOR
        FDB      ZBRAN
        FDB      INTE3-*-CW ;IF
        FDB      EXEC
        FDB      BRAN
        FDB      INTE4-*-CW ;IF
INTE3:
        FDB      COMMA
                        ;THEN
INTE4:
        FDB      QSTAC
        FDB      BRAN
        FDB      INTE1-*-CW  ;AGAIN
INTE8:  FDB      DROP, DROP
        FDB      SEMIS
;

;  *****************
;  *   IMMEDIATE   *
;  *****************
;
N_IMMED:   FDB      9
        FCC      "IMMEDIATE"
IMMED:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+INTER
        FDB    N_IMMED

        FDB      LATEST
        FDB      TFFA
        FDB      LIT, B_IMMED
        FDB      TOGGL
        FDB      SEMIS
;

;  ******************
;  *   VOCABULARY   *
;  ******************
;
N_VOCAB:   FDB      10
        FCC      "VOCABULARY"
VOCAB:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+IMMED
        FDB    N_VOCAB

        FDB      CREATE
        FDB      LATEST   ; Link this DEA into VOC-LINK chain.
        FDB      VOCL
        FDB      FETCH
        FDB      COMMA
        FDB      VOCL
        FDB      STORE
        FDB      ZERO, COMMA   ; Dummy code field
        FDB      ZERO, COMMA   ; Dummy data field
        FDB      LIT, B_DUMMY, COMMA ; Dummy flag field
        FDB      ZERO, COMMA ;Links to the word FORTH

        FDB      DOES
DOVOC:
        FDB      ALSO
        FDB      CELLP   ; Make it a WID. 
        FDB      CONTEXT
        FDB      STORE
        FDB      SEMIS
        ;
;

;  *******************
;  *   DEFINITIONS   *
;  *******************
;
N_DEFIN:   FDB      11
        FCC      "DEFINITIONS"
DEFIN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+VOCAB
        FDB    N_DEFIN

        FDB      CONTEXT
        FDB      FETCH
        FDB      CURR
        FDB      STORE
        FDB      SEMIS
;

;  ************
;  *   ALSO   *
;  ************
;
N_ALSO:   FDB      4
        FCC      "ALSO"
ALSO:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DEFIN
        FDB    N_ALSO

        FDB      CONTEXT, LDUP, CELLP
        FDB      LIT, 8-1*CW
        FDB      LMOVE
        FDB      LIT, FORTH  ;End sentinel for array of word lists.
        FDB      CONTEXT, LIT, 8*CW, PLUS
        FDB      STORE ;Trim sets of wordset.
        FDB      SEMIS
;

;  ****************
;  *   PREVIOUS   *
;  ****************
;
N_PREVI:   FDB      8
        FCC      "PREVIOUS"
PREVI:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ALSO
        FDB    N_PREVI

        FDB      CONTEXT, LDUP, CELLP, SWAP
        FDB      LIT, 8*CW
        FDB      LMOVE
        FDB      SEMIS
;

;  ************
;  *   ONLY   *
;  ************
;
N_ONLY:   FDB      4
        FCC      "ONLY"
ONLY:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PREVI
        FDB    N_ONLY

        FDB      LIT, FORTH, CONTEXT, STORE
        FDB      CONTEXT, LDUP, CELLP
        FDB      LIT, 8-1*CW
        FDB      LCMOVE
        FDB      SEMIS
;

;  *********
;  *   (   *
;  *********
;
N_PAREN:   FDB      1
        FCC      "("
PAREN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+ONLY
        FDB    N_PAREN

        FDB      LIT,ARC
        FDB      PPARS
        FDB      TDROP
        FDB      SEMIS
;
;

;  *********
;  *   \   *
;  *********
;
N_BACKS:   FDB      1
        FCC      "\"
BACKS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+PAREN
        FDB    N_BACKS

        FDB      LIT,ALF
        FDB      PPARS
        FDB      TDROP
        FDB      SEMIS
;

;  ************
;  *   QUIT   *
;  ************
;
N_QUIT:   FDB      4
        FCC      "QUIT"
QUIT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BACKS
        FDB    N_QUIT

        FDB      LBRAC
QUIT1:                  ;BEGIN
        FDB      RZERO
        FDB      FETCH
        FDB      RPSTO

        FDB      PACCEP
;
        FDB       SETSRC
        FDB      INTER
        FDB      OK
        FDB      BRAN
        FDB      QUIT1-*-CW  ;AGAIN
        FDB      SEMIS   ;Unnecessary, but helpful for decompilation.
;

;  **********
;  *   OK   *
;  **********
;
N_OK:   FDB      2
        FCC      "OK"
OK:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QUIT
        FDB    N_OK

        FDB      STATE
        FDB      FETCH
        FDB      ZEQU
        FDB      ZBRAN
        FDB      OK2-*-CW ;IF
        FDB      SKIP
         FDB      3
SB4: FCC      " OK"
       
        FDB      LIT, SB4
        FDB      LIT, 3
        FDB      LTYPE
OK2:
        FDB      CR
        FDB      SEMIS
;

;  *************
;  *   ABORT   *
;  *************
;
N_ABORT:   FDB      5
        FCC      "ABORT"
ABORT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+OK
        FDB    N_ABORT

        FDB      SZERO, FETCH, SPSTO
        FDB      ZERO, HANDLER, STORE
        FDB      DECA
        FDB      ONLY
        FDB      FORTH
        FDB      DEFIN
        FDB      QUIT
        FDB      SEMIS   ;Unnecessary, but helpful for decompilation.
;
;      WARM START VECTOR COMES HERE
;      For booting code we enter here, real mode and using the switchsegment.
;      BY control BREAK.
WARM_ENTRY:
        
        LDY     #WRM1
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]                   ;Hope stacks are still okay.
;
WRM1:   FDB      WARM
;

;  ************
;  *   WARM   *
;  ************
;
N_WARM:   FDB      4
        FCC      "WARM"
WARM:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ABORT
        FDB    N_WARM

        FDB      INIT
        FDB      SIGNON
        FDB      ABORT
        FDB      SEMIS   ;Unnecessary, but helpful for decompilation.
;


;  ***************
;  *   VOC>RAM   *
;  ***************
;
N_VOCTRAM:   FDB      7
        FCC      "VOC>RAM"
VOCTRAM:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+WARM
        FDB    N_VOCTRAM

        FDB      LDUP, TPHA
        FDB      SWAP, TDFA, FETCH
        FDB      LIT, 14, LCMOVE
        FDB      SEMIS
;
;

;  ************
;  *   COLD   *
;  ************
;
N_COLD:   FDB      4
        FCC      "COLD"
COLD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+VOCTRAM
        FDB    N_COLD

CLD1:
; Fill user area for single task.
        FDB      LIT, USINI
        FDB      LIT, 1*CW+USINI, FETCH
        FDB      LIT, US
        FDB      LCMOVE
        FDB      LIT, -C_HOFFSET*CW+VOCTRAM, FORV
        FDB      LIT, USART_CMD, CFET, DROP         'reset
; mode 1 : 1 stopbit, no parity, 8 databits, asynchronous 16X baudratefactor 
        FDB      LIT, $4E, LIT, USART_MODE, CSTOR
; set mode reg. 2 : internal clock, 4800 Bd )
        FDB      LIT, $7C, LIT, USART_MODE, CSTOR
; RTS high, reset error, no break, enable Rx, DTR high, enable Tx
        FDB      LIT, $15, LIT, USART_CMD, CSTOR
        FDB      LIT, APERC, EMIT
        FDB      WARM
        FDB      SEMIS   ; Unnecessary, but helpful for decompilation.
;

;  ************
;  *   INIT   *
;  ************
;
N_INIT:   FDB      4
        FCC      "INIT"
INIT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+COLD
        FDB    N_INIT

        FDB      SZERO, FETCH, SPSTO
        FDB      ZERO, HANDLER, STORE
        FDB      DECA
        FDB      ONLY, FORTH, DEFIN
                 FDB      SEMIS
;

;  ***********
;  *   RTI   *
;  ***********
;
N_LRTI:   FDB      3
        FCC      "RTI"
LRTI:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+INIT
        FDB    N_LRTI

RTI1:   RTI
;

;  ***********
;  *   S>D   *
;  ***********
;
N_STOD:   FDB      3
        FCC      "S>D"
STOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LRTI
        FDB    N_STOD

        FDB      LDUP, ZLESS
        FDB      SEMIS
;

;  ***********
;  *   ABS   *
;  ***********
;
N_LABS:   FDB      3
        FCC      "ABS"
LABS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+STOD
        FDB    N_LABS

        FDB      LDUP
        FDB      ZLESS
        FDB      ZBRAN
        FDB      PM1-*-CW   ;IF
        FDB      NEGATE   ;THEN
PM1:
        FDB      SEMIS
;

;  ************
;  *   DABS   *
;  ************
;
N_DABS:   FDB      4
        FCC      "DABS"
DABS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LABS
        FDB    N_DABS

        FDB      LDUP
        FDB      ZLESS
        FDB      ZBRAN
        FDB      DPM1-*-CW  ;IF
        FDB      DNEGA   ;THEN
DPM1:
        FDB      SEMIS
;

;  ***********
;  *   MIN   *
;  ***********
;
N_MIN:   FDB      3
        FCC      "MIN"
MIN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DABS
        FDB    N_MIN

        FDB      TDUP
        FDB      GREAT
        FDB      ZBRAN
        FDB      MIN1-*-CW  ;IF
        FDB      SWAP    ;THEN
MIN1:   FDB      DROP
        FDB      SEMIS
;

;  ***********
;  *   MAX   *
;  ***********
;
N_MAX:   FDB      3
        FCC      "MAX"
MAX:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+MIN
        FDB    N_MAX

        FDB      TDUP
        FDB      LESS
        FDB      ZBRAN
        FDB      MAX1-*-CW  ;IF
        FDB      SWAP    ;THEN
MAX1:   FDB      DROP
        FDB      SEMIS
;

;  **************
;  *   LSHIFT   *
;  **************
;
N_LSHIFT:   FDB      6
        FCC      "LSHIFT"
LSHIFT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+MAX
        FDB    N_LSHIFT

        PULU    X
        PULU    D
        LEAX    0,X
        BEQ     LSH2
LSH1:   LSLB
        ROLA
        LEAX    -1,X
        BNE     LSH1
LSH2:
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **************
;  *   RSHIFT   *
;  **************
;
N_RSHIFT:   FDB      6
        FCC      "RSHIFT"
RSHIFT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LSHIFT
        FDB    N_RSHIFT

        PULU    X
        PULU    D
        LEAX    0,X
        BEQ     RSH2
RSH1:   LSRA
        RORB
        LEAX    -1,X
        BNE     RSH1
RSH2:
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   M*   *
;  **********
;
N_MSTAR:   FDB      2
        FCC      "M*"
MSTAR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RSHIFT
        FDB    N_MSTAR

        FDB      TDUP, LXOR, TOR
        FDB      SWAP, LABS, SWAP, LABS
        FDB      USTAR
        FDB      FROMR, ZLESS
        FDB      ZBRAN
        FDB      MSTA1-*-CW
        FDB      DNEGA
MSTA1:
        FDB      SEMIS
;

;  **************
;  *   SM/REM   *
;  **************
;
N_MSLAS:   FDB      6
        FCC      "SM/REM"
MSLAS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+MSTAR
        FDB    N_MSLAS

        FDB      TDUP, LXOR, TOR
        FDB      OVER, TOR
        FDB      LABS, TOR, DABS, FROMR
        FDB      USLAS
        FDB      SWAP, FROMR, ZLESS
        FDB      ZBRAN
        FDB      MSLAS1-*-CW
        FDB      NEGATE
MSLAS1:
        FDB      SWAP, FROMR, ZLESS
        FDB      ZBRAN
        FDB      MSLAS2-*-CW
        FDB      NEGATE
MSLAS2:
        FDB      SEMIS
;


;  **********
;  *   2/   *
;  **********
;
N_TWOSL:   FDB      2
        FCC      "2/"
TWOSL:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+MSLAS
        FDB    N_TWOSL

    PULU    D
    ASRA
    RORB
    PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   2*   *
;  **********
;
N_TWOST:   FDB      2
        FCC      "2*"
TWOST:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TWOSL
        FDB    N_TWOST

    PULU    D
    ASLB
    ROLA
    PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;

;  **********
;  *   1-   *
;  **********
;
N_ONEM:   FDB      2
        FCC      "1-"
ONEM:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+TWOST
        FDB    N_ONEM

        FDB      ONE, LSUB
        FDB      SEMIS
;
;

;  **************
;  *   FM/MOD   *
;  **************
;
N_FMSLAS:   FDB      6
        FCC      "FM/MOD"
FMSLAS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ONEM
        FDB    N_FMSLAS

        FDB      LDUP, TOR
        FDB      TDUP, LXOR, TOR
        FDB      MSLAS
        FDB      FROMR, ZLESS
        FDB      ZBRAN
        FDB      FMMOD1-*-CW
        FDB      OVER
        FDB      ZBRAN
        FDB      FMMOD1-*-CW
        FDB      ONE, LSUB
        FDB      SWAP, FROMR, PLUS, SWAP
        FDB      BRAN
        FDB      FMMOD2-*-CW
FMMOD1:
        FDB      RDROP
FMMOD2:
        FDB      SEMIS
;

;  *********
;  *   *   *
;  *********
;
N_STAR:   FDB      1
        FCC      "*"
STAR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FMSLAS
        FDB    N_STAR

        FDB      MSTAR
        FDB      DROP
        FDB      SEMIS
;

;  ************
;  *   /MOD   *
;  ************
;
N_SLMOD:   FDB      4
        FCC      "/MOD"
SLMOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+STAR
        FDB    N_SLMOD

        FDB      TOR
        FDB      STOD
        FDB      FROMR
        FDB      MSLAS
        FDB      SEMIS
;

;  *********
;  *   /   *
;  *********
;
N_SLASH:   FDB      1
        FCC      "/"
SLASH:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SLMOD
        FDB    N_SLASH

        FDB      SLMOD
        FDB      SWAP
        FDB      DROP
        FDB      SEMIS
;

;  ***********
;  *   MOD   *
;  ***********
;
N_LMOD:   FDB      3
        FCC      "MOD"
LMOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SLASH
        FDB    N_LMOD

        FDB      SLMOD
        FDB      DROP
        FDB      SEMIS
;

;  *************
;  *   */MOD   *
;  *************
;
N_SSMOD:   FDB      5
        FCC      "*/MOD"
SSMOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LMOD
        FDB    N_SSMOD

        FDB      TOR
        FDB      MSTAR
        FDB      FROMR
        FDB      MSLAS
        FDB      SEMIS
;

;  **********
;  *   */   *
;  **********
;
N_SSLA:   FDB      2
        FCC      "*/"
SSLA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SSMOD
        FDB    N_SSLA

        FDB      SSMOD
        FDB      SWAP
        FDB      DROP
        FDB      SEMIS
;

;  *************
;  *   M/MOD   *
;  *************
;
N_MSMOD:   FDB      5
        FCC      "M/MOD"
MSMOD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SSLA
        FDB    N_MSMOD

        FDB      TOR
        FDB      ZERO
        FDB      RR
        FDB      USLAS
        FDB      FROMR
        FDB      SWAP
        FDB      TOR
        FDB      USLAS
        FDB      FROMR
        FDB      SEMIS
;
;

;  ************
;  *   SAVE   *
;  ************
;
N_SAVE:   FDB      4
        FCC      "SAVE"
SAVE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+MSMOD
        FDB    N_SAVE

        FDB      FROMR
        FDB      SRC, TFET
        FDB      LIN, FETCH
        FDB      TOR, TOR, TOR
        FDB      TOR
        FDB SEMIS
;

;  ***************
;  *   RESTORE   *
;  ***************
;
N_RESTO:   FDB      7
        FCC      "RESTORE"
RESTO:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SAVE
        FDB    N_RESTO

        FDB      FROMR
        FDB      FROMR, FROMR, FROMR
        FDB      LIN, STORE
        FDB      SRC, TSTOR
        FDB      TOR
        FDB SEMIS
;


;  ******************
;  *   SAVE-INPUT   *
;  ******************
;
N_SAVEI:   FDB      10
        FCC      "SAVE-INPUT"
SAVEI:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RESTO
        FDB    N_SAVEI

        FDB      SRC, TFET
        FDB      LIN, FETCH
        FDB      LIT, 3
        FDB SEMIS
;

;  *********************
;  *   RESTORE-INPUT   *
;  *********************
;
N_RESTOI:   FDB      13
        FCC      "RESTORE-INPUT"
RESTOI:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SAVEI
        FDB    N_RESTOI

        FDB      DROP
        FDB      LIN, STORE
        FDB      SRC, TSTOR
        FDB      LIT, -1
        FDB SEMIS
;
;
;
        ;
; --- --------------------------------
;       SYSTEM DEPENDANT CHAR I/O
;------------------------------------


;  **************
;  *   ACCEPT   *
;  **************
;
N_ACCEP:   FDB      6
        FCC      "ACCEPT"
ACCEP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+RESTOI
        FDB    N_ACCEP

        FDB      PACCEP
        FDB      TSWAP, ROT, MIN
        FDB      LDUP, TOR, LMOVE, FROMR
        FDB      SEMIS
;
;


;  ****************
;  *   (ACCEPT)   *
;  ****************
;
N_PACCEP:   FDB      8
        FCC      "(ACCEPT)"
PACCEP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ACCEP
        FDB    N_PACCEP

        FDB      TIB
        FDB      FETCH
        FDB      LIT,RTS/2
        FDB      TDUP
;  Old fig code of EXPECT :
             FDB      OVER
             FDB      PLUS
             FDB      OVER
             FDB     XDO
        FDB      EXPE8-*-CW
EXPE1:       FDB      KEY
             FDB      LDUP
             FDB      RUBOUT
             FDB      FETCH
             FDB      EQUAL
             FDB      ZBRAN
        FDB      EXPE2-*-CW ; IF                    
             FDB      DROP
             FDB      LDUP
             FDB      IDO
             FDB      EQUAL
             FDB      LDUP
             FDB      FROMR
             FDB      TWO     ; Remove last 2 chars 
             FDB      LSUB
             FDB      PLUS
             FDB      TOR
             FDB      ZBRAN
        FDB      EXPE6-*-CW ; IF                    
             FDB      LIT
             FDB      BELL
             FDB      BRAN
        FDB      EXPE7-*-CW  ; ELSE                  
EXPE6:       FDB      LIT
             FDB      BSOUT   ; THEN                 
EXPE7:       FDB      BRAN
        FDB      EXPE3-*-CW  ; ELSE                  
EXPE2:       FDB      LDUP
             FDB      LIT,$0D
             FDB      EQUAL
             FDB      ZBRAN
        FDB      EXPE4-*-CW ; IF
             ; Emulate old fashioned LEAVE.
             FDB      FROMR, RDROP, LDUP, TOR, TOR
             FDB      DROP
             FDB      LBL
             FDB      ZERO
             FDB      BRAN
        FDB      EXPE5-*-CW  ; ELSE
EXPE4:       FDB      LDUP    ; THEN
EXPE5:       FDB      IDO
             FDB      CSTOR
             FDB      ZERO
             FDB      IDO
             FDB      ONEP
             FDB      STORE   ; THEN
EXPE3:       FDB      EMIT
             FDB     XLOOP
        FDB      EXPE1-*-CW    ; LOOP
EXPE8:
             FDB      DROP
;        ;      EXPEC
        FDB      ZERO, SINDEX
        FDB      TIB, FETCH, SWAP, OVER, LSUB
        FDB      SEMIS
;
 ; 

        ;
;------------------------------------
;       SYSTEM DEPENDANT I/O
;------------------------------------


;  **************
;  *   (EMIT)   *
;  **************
;
N_PEMIT:   FDB      6
        FCC      "(EMIT)"
PEMIT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PACCEP
        FDB    N_PEMIT

        PULU    D
        BSR     PEMIT1
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]


;  **********
;  *   H.   *
;  **********
;
N_HDOT:   FDB      2
        FCC      "H."
HDOT:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PEMIT
        FDB    N_HDOT

        BSR     TWOBYTES
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
;
TWOBYTES:         ; H. as a subroutine.
    BSR  ONEBYTE  ; m.s.byte. Fall through for l.s. byte.
ONEBYTE:      ; Pop and print one byte.
     LDB  ,U
     LSRB
     LSRB
     LSRB
     LSRB
     BSR ONEDIG ; Emit m.s.digit
     PULU  B
     ANDB #$F   ; Fall through: emit l.s. digit
ONEDIG:         ; Print one hex digit from B
     ADDB #A0
     CMPB #A9
     BLE ENDIF
     ADDB #AA-A9-1
ENDIF:             ; Fall through to emit
; Callable from assembly, with character in D.
PEMIT1: LDA   USART_STATUS   ; Get ACIA status
        LSRA                 ; Check if ready to transmit
        BCC   PEMIT1         ; Loop if not ready
        STB   USART_DATA     ; Transmit character
        RTS

; PEMI1:                                                            *
;         FDB      LIT, USART_STATUS                                 *
;       FDB      CFET, LIT, 1, LAND                                  *
;      _0BRANCH(PEMI1)                                             *
;       FDB      LIT, USART_DATA, CSTOR                              *
;       FDB      SEMIS                                               *
;

;  ************
;  *   EMIT   *
;  ************
;
N_EMIT:   FDB      4
        FCC      "EMIT"
EMIT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+HDOT
        FDB    N_EMIT

             FDB      ONE,LOUT,PSTORE
             FDB      LIT, $07F, LAND
             FDB      LDUP,LIT,ALF,EQUAL
             FDB      ZBRAN
        FDB      EMIT1-*-CW
             FDB      LIT,ACR,PEMIT
             FDB      ZERO,LOUT,STORE
EMIT1:       FDB      PEMIT
             FDB      SEMIS
;

;  ***********
;  *   KEY   *
;  ***********
;
N_KEY:   FDB      3
        FCC      "KEY"
KEY:        FDB    PH_OFFSET-C_HOFFSET*CW+*
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+EMIT
        FDB    N_KEY

        BSR     KEY1
        PSHU    D
        LDX   ,Y++           ; NEXT
        JMP   [C_HOFFSET*CW,X]
; Callable from assembly, with character in D.
KEY1:   LDA   USART_STATUS   ; Get control status of the ACIA
        BITA  #$02           ; Check if buffer is empty (=Z)
        BEQ   KEY1           ; If so wait.
        LDB   USART_DATA     ; If not, get key
        CLRA
        RTS
;KEY1:                                                              *
;       FDB      KEYQ                                                *
;      _0BRANCH(KEY1)                                              *
;       FDB      LIT, USART_DATA, CFET                               *
;       FDB      SEMIS                                               *
;

;  ************
;  *   KEY?   *
;  ************
;
N_KEYQ:   FDB      4
        FCC      "KEY?"
KEYQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+KEY
        FDB    N_KEYQ

        FDB      LIT, USART_STATUS
        FDB      CFET, LIT, 2, LAND
        FDB      ZEQU, ZEQU
        FDB      SEMIS
;

;  ************
;  *   TYPE   *
;  ************
;
N_LTYPE:   FDB      4
        FCC      "TYPE"
LTYPE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+KEYQ
        FDB    N_LTYPE

             FDB      QDUP
             FDB      ZBRAN
        FDB      TYPE1-*-CW
             FDB      OVER,   PLUS
             FDB      SWAP
             FDB     XDO
        FDB      TYPE4-*-CW
TYPE2:       FDB      IDO,    CFET,    EMIT
             FDB     XLOOP
        FDB      TYPE2-*-CW
             FDB      BRAN
        FDB      TYPE3-*-CW
TYPE4:
TYPE1:       FDB      DROP
TYPE3:       FDB      SEMIS
;
;

;  *********
;  *   '   *
;  *********
;
N_ITICK:   FDB      1
        FCC      "'"
ITICK:        FDB    DOCOL 
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LTYPE
        FDB    N_ITICK

        FDB      LPWORD, PRESENT
        FDB      LDUP, ZEQU
        FDB      LIT, 11, QERR
        FDB      SEMIS
;

;  ***********
;  *   [']   *
;  ***********
;
N_BTICK:   FDB      3
        FCC      "[']"
BTICK:        FDB    DOCOL
        FDB    PH_OFFSET-C_HOFFSET*CW+TICK
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+ITICK
        FDB    N_BTICK

;

;  ******************
;  *   FORGET-VOC   *
;  ******************
;
N_FORGV:   FDB      10
        FCC      "FORGET-VOC"
FORGV:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BTICK
        FDB    N_FORGV

        FDB      TDUP
        FDB      SWAP
        FDB      ULESS
        FDB      ZBRAN
        FDB      FORGV1-*-CW
;  Forget part of contents.
        FDB      SWAP
        FDB      TOR
        FDB      TWID
        FDB      LDUP
FORGV3:
        FDB      TLFA,FETCH    ; Next voc
        FDB      LDUP
        FDB      RR
        FDB      ULESS
        FDB      ZBRAN
        FDB      FORGV3-*-CW
        FDB      SWAP
        FDB      TLFA
        FDB      STORE
        FDB      FROMR
        FDB      BRAN
        FDB      FORGV2-*-CW
FORGV1:
;        Vocabulary itself is also forgotten.
        FDB      TVFA
        FDB      FETCH     ; Unlink by linking next vocabulary.
        FDB      VOCL
        FDB      STORE
        FDB      ONLY, FORTH
        FDB      DEFIN
FORGV2: FDB      SEMIS
;

;  **************
;  *   FORGET   *
;  **************
;
N_FORG:   FDB      6
        FCC      "FORGET"
FORG:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FORGV
        FDB    N_FORG

        FDB      TICK
        FDB      LDUP
        FDB      FENCE
        FDB      FETCH
        FDB      LESS
        FDB      LIT, 21, QERR
        FDB      LIT,FORGV
        FDB      FORV
        FDB      TNFA, FETCH, LDP, STORE
        FDB      SEMIS
;

;  *************
;  *   (BACK   *
;  *************
;
N_PBACK:   FDB      5
        FCC      "(BACK"
PBACK:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FORG
        FDB    N_PBACK

        FDB      HERE
        FDB      SEMIS
;

;  *************
;  *   BACK)   *
;  *************
;
N_BACKP:   FDB      5
        FCC      "BACK)"
BACKP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PBACK
        FDB    N_BACKP

        FDB      HERE
        FDB      CELLP
        FDB      LSUB
        FDB      COMMA
        FDB      SEMIS
;

;  ****************
;  *   (FORWARD   *
;  ****************
;
N_PFORWARD:   FDB      8
        FCC      "(FORWARD"
PFORWARD:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BACKP
        FDB    N_PFORWARD

        FDB      HERE
        FDB      X
        FDB      COMMA
        FDB      SEMIS
;

;  ****************
;  *   FORWARD)   *
;  ****************
;
N_FORWARDP:   FDB      8
        FCC      "FORWARD)"
FORWARDP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PFORWARD
        FDB    N_FORWARDP

        FDB      HERE
        FDB      OVER
        FDB      CELLP
        FDB      LSUB
        FDB      SWAP
        FDB      STORE
        FDB      SEMIS
;

;  *************
;  *   BEGIN   *
;  *************
;
N_BEGIN:   FDB      5
        FCC      "BEGIN"
BEGIN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+FORWARDP
        FDB    N_BEGIN

        FDB      PBACK
        FDB      QCOMP, ONE
        FDB      SEMIS
;

;  ************
;  *   THEN   *
;  ************
;
N_THEN:   FDB      4
        FCC      "THEN"
THEN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+BEGIN
        FDB    N_THEN

        FDB      QCOMP, TWO, QPAIR
        FDB      FORWARDP
        FDB      SEMIS
;

;  **********
;  *   DO   *
;  **********
;
N_DO:   FDB      2
        FCC      "DO"
DO:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+THEN
        FDB    N_DO

         FDB      LIT, XDO, COMMA, PFORWARD, PBACK
        FDB      LIT,3    ; Magic number
        FDB      SEMIS
;

;  ***********
;  *   ?DO   *
;  ***********
;
N_QDO:   FDB      3
        FCC      "?DO"
QDO:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+DO
        FDB    N_QDO

         FDB      LIT, XQDO, COMMA, PFORWARD, PBACK
        FDB      LIT,3    ; Magic number
        FDB      SEMIS
;

;  ************
;  *   LOOP   *
;  ************
;
N_LLOOP:   FDB      4
        FCC      "LOOP"
LLOOP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+QDO
        FDB    N_LLOOP

        FDB      LIT, 3, QPAIR
        FDB      LIT, XLOOP, COMMA, BACKP
        FDB      FORWARDP ; For DO to push the leave address.
        FDB      SEMIS
;

;  *************
;  *   +LOOP   *
;  *************
;
N_PLOOP:   FDB      5
        FCC      "+LOOP"
PLOOP:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+LLOOP
        FDB    N_PLOOP

        FDB      LIT, 3, QPAIR
        FDB      LIT, XPLOO, COMMA, BACKP
        FDB      FORWARDP ; For DO to push the leave address.
        FDB      SEMIS
;

;  *************
;  *   UNTIL   *
;  *************
;
N_UNTIL:   FDB      5
        FCC      "UNTIL"
UNTIL:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+PLOOP
        FDB    N_UNTIL

        FDB      ONE, QPAIR
        FDB      LIT, ZBRAN, COMMA, BACKP
        FDB      SEMIS
;

;  *************
;  *   AGAIN   *
;  *************
;
N_AGAIN:   FDB      5
        FCC      "AGAIN"
AGAIN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+UNTIL
        FDB    N_AGAIN

        FDB      ONE, QPAIR
        FDB      LIT, BRAN, COMMA, BACKP
        FDB      SEMIS
;

;  **************
;  *   REPEAT   *
;  **************
;
N_REPEA:   FDB      6
        FCC      "REPEAT"
REPEA:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+AGAIN
        FDB    N_REPEA

        FDB      ONE, QPAIR   ; Matches BEGIN ?
        FDB      LIT, BRAN, COMMA, BACKP
        FDB      QCOMP, LIT, 4, QPAIR ; Matches WHILE ?
        FDB      FORWARDP ; WHILE target. 
        FDB      SEMIS
;

;  **********
;  *   IF   *
;  **********
;
N_LIF:   FDB      2
        FCC      "IF"
LIF:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+REPEA
        FDB    N_LIF

        FDB      LIT, ZBRAN, COMMA, PFORWARD
        FDB      TWO     ; Magic number
        FDB      SEMIS
;

;  ************
;  *   ELSE   *
;  ************
;
N_LELSE:   FDB      4
        FCC      "ELSE"
LELSE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+LIF
        FDB    N_LELSE

        FDB      QCOMP, TWO, QPAIR
        FDB      LIT, BRAN, COMMA, PFORWARD
        FDB      SWAP
        FDB      FORWARDP
        FDB      TWO     ; Magic number
        FDB      SEMIS
;

;  *************
;  *   WHILE   *
;  *************
;
N_LWHILE:   FDB      5
        FCC      "WHILE"
LWHILE:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    B_IMMED
        FDB    -C_HOFFSET*CW+LELSE
        FDB    N_LWHILE

        FDB      TOR    ;  Save backward target. 
        FDB      TOR
        FDB      LIT, ZBRAN, COMMA, PFORWARD
        FDB      LIT, 4 ; Magic number
        FDB      FROMR
        FDB      FROMR
        FDB      SEMIS
;

;  **************
;  *   SPACES   *
;  **************
;
N_SPACES:   FDB      6
        FCC      "SPACES"
SPACES:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+LWHILE
        FDB    N_SPACES

        FDB      ZERO
        FDB      MAX
        FDB      ZERO
        FDB     XQDO
        FDB      SPAX1-*-CW
SPAX2:  FDB      SPACE
        FDB     XLOOP
        FDB      SPAX2-*-CW    ;LOOP
SPAX1:
        FDB      SEMIS
;

;  **********
;  *   <#   *
;  **********
;
N_BDIGS:   FDB      2
        FCC      "<#"
BDIGS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SPACES
        FDB    N_BDIGS

        FDB      PAD
        FDB      HLD
        FDB      STORE
        FDB      SEMIS
;

;  **********
;  *   #>   *
;  **********
;
N_EDIGS:   FDB      2
        FCC      "#>"
EDIGS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BDIGS
        FDB    N_EDIGS

        FDB      DROP
        FDB      DROP
        FDB      HLD
        FDB      FETCH
        FDB      PAD
        FDB      OVER
        FDB      LSUB
        FDB      SEMIS
;

;  ************
;  *   SIGN   *
;  ************
;
N_SIGN:   FDB      4
        FCC      "SIGN"
SIGN:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+EDIGS
        FDB    N_SIGN

        FDB      ZLESS
        FDB      ZBRAN
        FDB      SIGN1-*-CW ;IF
        FDB      LIT,$2D
        FDB      HOLD    ;THEN
SIGN1:  FDB      SEMIS
;

;  *********
;  *   #   *
;  *********
;
N_DIG:   FDB      1
        FCC      "#"
DIG:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SIGN
        FDB    N_DIG

        FDB      BASE
        FDB      FETCH
        FDB      MSMOD
        FDB      ROT
        FDB      LIT,9
        FDB      OVER
        FDB      LESS
        FDB      ZBRAN
        FDB      DIG1-*-CW  ;IF
        FDB      LIT,7
        FDB      PLUS    ;THEN
DIG1:   FDB      LIT,A0
        FDB      PLUS
        FDB      HOLD
        FDB      SEMIS
;

;  **********
;  *   #S   *
;  **********
;
N_DIGS:   FDB      2
        FCC      "#S"
DIGS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DIG
        FDB    N_DIGS

DIGS1:  FDB      DIG     ;BEGIN
        FDB      OVER
        FDB      OVER
        FDB      LOR
        FDB      ZEQU
        FDB      ZBRAN
        FDB      DIGS1-*-CW ;UNTIL
        FDB      SEMIS
;

;  *************
;  *   (D.R)   *
;  *************
;
N_PDDOTR:   FDB      5
        FCC      "(D.R)"
PDDOTR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DIGS
        FDB    N_PDDOTR

        FDB      TOR
        FDB      SWAP
        FDB      OVER
        FDB      DABS
        FDB      BDIGS
        FDB      DIGS
        FDB      ROT
        FDB      SIGN
        FDB      EDIGS
        FDB      FROMR
        FDB      OVER
        FDB      LSUB, ZERO, MAX
        FDB      ZERO
        FDB     XQDO
        FDB      PDDOT1-*-CW
PDDOT2:  FDB      LBL, HOLD  ;WARNING: HOLD outside of #>.
        FDB     XLOOP
        FDB      PDDOT2-*-CW
PDDOT1:
        FDB      EDIGS  ;Drop string instead of number.
        FDB      SEMIS
;

;  ***********
;  *   D.R   *
;  ***********
;
N_DDOTR:   FDB      3
        FCC      "D.R"
DDOTR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+PDDOTR
        FDB    N_DDOTR

        FDB      PDDOTR
        FDB      LTYPE
        FDB      SEMIS
;

;  **********
;  *   .R   *
;  **********
;
N_DOTR:   FDB      2
        FCC      ".R"
DOTR:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DDOTR
        FDB    N_DOTR

        FDB      TOR
        FDB      STOD
        FDB      FROMR
        FDB      DDOTR
        FDB      SEMIS
;

;  **********
;  *   D.   *
;  **********
;
N_DDOT:   FDB      2
        FCC      "D."
DDOT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DOTR
        FDB    N_DDOT

        FDB      ZERO
        FDB      DDOTR
        FDB      SPACE
        FDB      SEMIS
;

;  *********
;  *   .   *
;  *********
;
N_DOT:   FDB      1
        FCC      "."
DOT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DDOT
        FDB    N_DOT

; 
        FDB      STOD
        FDB      DDOT
        FDB      SEMIS
;

;  *********
;  *   ?   *
;  *********
;
N_QUES:   FDB      1
        FCC      "?"
QUES:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DOT
        FDB    N_QUES

        FDB      FETCH
        FDB      DOT
        FDB      SEMIS
;

;  **********
;  *   U.   *
;  **********
;
N_UDOT:   FDB      2
        FCC      "U."
UDOT:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+QUES
        FDB    N_UDOT

        FDB      ZERO
        FDB      DDOT
        FDB      SEMIS
;

;  *****************
;  *   FOR-WORDS   *
;  *****************
;
N_FORW:   FDB      9
        FCC      "FOR-WORDS"
FORW:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+UDOT
        FDB    N_FORW

        FDB      SWAP
        FDB      TOR
        FDB      TOR
FORW1:  FDB      FROMR
        FDB      RR
        FDB      OVER
        FDB      TLFA
        FDB      FETCH
        FDB      TOR
        FDB      EXEC
        FDB      RR
        FDB      ZEQU
        FDB      ZBRAN
        FDB      FORW1-*-CW
        FDB      RDROP
        FDB      RDROP
        FDB      SEMIS
;

;  ****************
;  *   FOR-VOCS   *
;  ****************
;
N_FORV:   FDB      8
        FCC      "FOR-VOCS"
FORV:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FORW
        FDB    N_FORV

        FDB      TOR
        FDB      VOCL
        FDB      FETCH
FORV1:  FDB      RR
        FDB      OVER, TOR
        FDB      EXEC
        FDB      FROMR
        FDB      TVFA
        FDB      FETCH
        FDB      LDUP
        FDB      ZEQU
        FDB      ZBRAN
        FDB      FORV1-*-CW
        FDB      DROP
        FDB      RDROP
        FDB      SEMIS
;

;  *************
;  *   WORDS   *
;  *************
;
N_WORDS:   FDB      5
        FCC      "WORDS"
WORDS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+FORV
        FDB    N_WORDS

        FDB      LIT, IDDOT
        FDB      CONTEXT
        FDB      FETCH
        FDB      FORW
        FDB      SEMIS
;

;  ***********
;  *   BYE   *
;  ***********
;
N_BYE:   FDB      3
        FCC      "BYE"
BYE:        FDB    $0
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+WORDS
        FDB    N_BYE

        FDB      LIT, 3
        FDB      EMIT
        FDB      SEMIS
;
;

;  **********
;  *   .S   *
;  **********
;
N_DOTS:   FDB      2
        FCC      ".S"
DOTS:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+BYE
        FDB    N_DOTS

        FDB      QSTAC
        FDB      CR
        FDB      LIT, AS, EMIT
        FDB      LIT, ASO, EMIT
        FDB      SPACE
        FDB      SPFET, SZERO, FETCH
DOC2:   FDB      OVER, OVER,  EQUAL, ZEQU
        FDB      ZBRAN
        FDB      DOC1-*-CW
        FDB      ZERO, CELLP, LSUB, LDUP, FETCH, DOT
        FDB      BRAN
        FDB      DOC2-*-CW
DOC1:    FDB DROP, DROP
        FDB      LIT, ASC, EMIT
        FDB SEMIS
;

;  ********************
;  *   ENVIRONMENT?   *
;  ********************
;
N_ENVQ:   FDB      12
        FCC      "ENVIRONMENT?"
ENVQ:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+DOTS
        FDB    N_ENVQ

        FDB      LIT, ENV, TWID, PFIND
        FDB      TOR, TDROP, FROMR
        FDB      LDUP
        FDB      ZBRAN
        FDB      ENVQ1-*-CW
        FDB      EXEC
        FDB      LIT, -1
ENVQ1:
        FDB      SEMIS
;
;

;  ***************
;  *   .SIGNON   *
;  ***************
;
N_SIGNON:   FDB      7
        FCC      ".SIGNON"
SIGNON:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+ENVQ
        FDB    N_SIGNON

; PRINT CPU TYPE (8088)
        FDB      CR
        FDB      BASE,FETCH
        FDB      LIT,36, BASE,STORE
        FDB      LCPU, DDOT
        FDB      BASE,STORE
;
        FDB      LNAME, LTYPE, SPACE
        FDB      LVERSION, LTYPE, SPACE
        FDB      CR
        FDB      SEMIS
;
;**** LAST DICTIONARY WORD ****

;  ************
;  *   TASK   *
;  ************
;
N_TASK:   FDB      4
        FCC      "TASK"
TASK:        FDB    DOCOL
        FDB    PH_OFFSET-D_HOFFSET*CW+*
        FDB    $0
        FDB    -C_HOFFSET*CW+SIGNON
        FDB    N_TASK

        FDB      SEMIS
;

TEXTEND  EQU     *       ; Show end of dictionary.
INITDP   EQU     1080
ACTUAL_EM EQU    EM  ; Different for relocatable code only.

        ZMB     $FFF0-*
; 6809 hardware vectors
        FDB      RTI1, RTI1, RTI1, RTI1        ; tbd, SWI3, SWI2, FIRQ
        FDB      RTI1, RTI1, RTI1, ORG0     ; IRQ, SWI, NMI, RESET
; 
 ;  



; 
;

        ;


; Define the entry point, not valid for auto booting.
        ;     ORIG



























