# $Id: test.mak,v 1.7 2004/01/27 11:40:58 albert Exp $
# Copyright(2000): Albert van der Horst, HCC FIG Holland by GNU Public License
#
# Contains the tests.
# It contains the tests for the assemblers too, which is probably inaproprate
# because these are in principle processor independant.

TESTTARGETS=*.ps testas* test.ci6809.[0-9] testmina.[0-9] testlinux.[0-9]

testclean: ; rm -f $(TESTTARGETS)

da : $(STEM).asm
		diff -w $(STEM).asm cmp > asm.dif ||true
		wc asm.dif

x : ; echo $(RELEASECONTENT)
y : ; echo $(RELEASECONTENT) |\
sed -e's/\<ci6809\.//g' |\
sed -e's/\<gnr\>/ci68.gnr/' |\
sed -e's/ \([^ .]\{1,8\}\)[^ .]*\./ \1./g'

# Testing of the assemblers is left in.
# All assemblers are relevant for all processors (in principle)
testas86: asgen.frt asi86.frt testset8086 ; \
    (echo 5 LOAD; cat $+)|\
    lina |\
    sed '1,/TEST STARTS HERE/d' |\
    sed 's/^[0-9A-F \.,]*://' >$@       ;\
    diff -w $@ testset8086 >$@.diff ;\
    diff $@.diff testresults

testas386: asgen.frt asi586.frt testset386 ; \
    (echo 5 LOAD; cat $+)|\
    lina |\
    sed '1,/TEST STARTS HERE/d' |\
    sed 's/^[0-9A-F \.,]*://' >$@       ;\
    diff -w $@ testset386 >$@.diff ;\
    diff $@.diff testresults

# Special test to exercise otherwise hidden instructions.
testas386a: asgen.frt asi586.frt testset386a ; \
    (echo 5 LOAD; cat $+)|\
    lina |\
    sed '1,/TEST STARTS HERE/d' |\
    sed '/^OK$$/d' |\
    sed 's/^[0-9A-F \.,]*://' >$@       ;\
    diff -w $@ testset386a >$@.diff ;\
    diff $@.diff testresults

testas80: asgen.frt as80.frt testset8080 ; \
    (echo 5 LOAD; cat $+)|\
    lina |\
    sed '1,/TEST STARTS HERE/d' |\
    sed 's/^[0-9A-F \.,]*://' >$@       ;\
    diff -w $@ testset8080 >$@.diff ;\
    diff $@.diff testresults

RELEASEASSEMBLER=      \
as80.frt        \
assembler.txt   \
asgen.frt       \
asi586.frt      \
asi86.frt       \
asm386endtest   \
ass.frt  \
p0.asi586.ps    \
p0F.asi586.ps   \
ps.frt    \
qr8086.ps       \
qr8080.ps       \
testset386      \
testset8080     \
testset8086     \
test.mak        \
# That's all folks!
# testset386a    (fails)

as.zip : $(RELEASEASSEMBLER) ; echo as$(VERSION) $+ | xargs zip

TEST6809= \
test.m4 \
$(STEM).rawtest

# Do all tests.
# This test always succeeds as far as make is concerned to make
# a run of all tests possible, even if one fails.
test : test.ci6809.3   tsuite.out ;
	make    test.ci6809.3  || true
	make    tsuite.out     || true

# The official ciforth regression test for this processor.
# No output is expected, except for an official version (VERSION=A.B.C)
# The version number shows up in the diff.
test.ci6809.3   : change.frt test.ci6809.1 ci6809.s19 ;
	echo citest |kermit|sed -e 's///g' | \
         sed -e 's/
//g' >test.ci6809.3
	diff -b -B test.ci6809.2 test.ci6809.3

# The John Hayes test.
tsuite.out  : changeh.frt tsuite.frt ci6809.s19 ;
	echo tsuite |kermit >tsuite.out
	diff -b -B tsuite.out testresults

test.ci6809.1 : $(STEM).rawtest test.m4 ;
	m4 test.m4 $<  >$(TEMPFILE)
	sed $(TEMPFILE) -e '/Split here for test/,$$d' >test.ci6809.1
	sed $(TEMPFILE) -e '1,/Split here for test/d' >test.ci6809.2
	rm $(TEMPFILE)
